TITLE	LinearSearchStr.asm

.486
.model flat, stdcall      ; memory model & calling convention
option casemap :none      ; case sensitive

externdef stdcall strCompareA :proto str1:dword, str2:dword

.code
align 16
; ----------------------------------------------------------------------------
; prototype:
; LPVOID __stdcall LinearSearchStrA(
;		LPVOID pTarget,
;		LPVOID pArray,
;		DWORD dwArrayCount,
;		DWORD dwElemSize
;		DWORD dwOffset);
; ----------------------------------------------------------------------------
LinearSearchStrA proc public uses ebx pTarget:dword, pArray:dword, dwArrayCount:dword, dwElemSize:dword, dwOffset:dword
; set up EAX register with our array for searching
	mov	eax, pArray
	lea	eax, [eax + dwOffset]
	
; set up EBX register with what we are looking for in the array
	mov	ebx, pTarget

; do a quick compare and see if the first element matches
	cmp 	ebx, [eax]
	je		short __LinearSearchStrFound
	
; set up ECX with the ending array address for our loop
	mov	ecx, dwArrayCount
	lea	ecx, [eax + ecx]
	
; set up EDX with the element size to move the array pointer
; when a no-match is found
	mov	edx, dwElemSize

; search for the pTarget in the array
__LinearSearchStrLoop:
; didn't find it, so increment the array address value with our element size
; to get to the next element
	add	eax, edx

; see if we have reached the end of the array
	cmp 	ecx, eax
	je		short __LinearSearchStrNotFound

; compare and see if the element matches.
	push  eax
	mov	eax, [eax]
	push  eax
	mov	eax, [ebx]
	push	eax
	call	dword ptr strCompareA
	test	eax, eax
	pop	eax
	je		short __LinearSearchStrFound
	jne	short __LinearSearchStrLoop

; we have reached the end -- need to set eax to NULL for our return value
__LinearSearchStrNotFound:
	sub	eax, eax
	jmp	__LinearSearchStrEnd
	
__LinearSearchStrFound:
	sub	eax, dwOffset

__LinearSearchStrEnd:
	ret
LinearSearchStrA ENDP


end
