TITLE "linear search (top to bottom)"

.586
.model flat, stdcall	; memory model
option casemap:none	    ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
; (none)


.code
; ----------------------------------------------------------------------------
; prototype:
;   LPVOID __stdcall LinearSearchNum(LPVOID pTarget, LPVOID pArray, DWORD dwArrayCount, DWORD dwElemSize DWORD dwOffset);
;
; Description:
;   Does a linear search (top to bottom) for Target value.
;
; Returns:
;   A pointer to the element in array if found otherwise NULL.
; ============================================================================
align 16
LinearSearchNum proc public uses ebx pTarget:dword, pArray:dword, dwArrayCount:dword, dwElemSize:dword, dwOffset:dword
; set up EAX register with our array for searching
	mov	eax, pArray
	lea	eax, [eax + dwOffset]
	
; set up EBX register with what we are looking for in the array
	mov	ebx, [pTarget]

; compare and see if the element matches.
	cmp	ebx, [eax]
	je		short __LinearSearchNumFound

; set up ECX with the ending array address for our loop
	mov	ecx, [dwArrayCount]
	lea	ecx, [eax + ecx]
	
; set up EDX with the element size to move the array pointer
; when a no-match is found
	mov	edx, [dwElemSize]

; search for the pTarget in the array
__LinearSearchNumLoop:

; didn't find it, so increment the array address value with our element size
; to get to the next element
	add	eax, edx

; see if we have reached the end of the array
	cmp 	ecx, eax
	je		short __LinearSearchNumNotFound

; compare and see if the element matches.
	cmp	ebx, [eax]
	je		short __LinearSearchNumFound
	jne	short __LinearSearchNumLoop

; we have reached the end -- need to set eax to NULL for our return value
__LinearSearchNumNotFound:
	sub	eax, eax
	jmp	__LinearSearchNumEnd
	
__LinearSearchNumFound:
	sub	eax, dwOffset

__LinearSearchNumEnd:
	ret
LinearSearchNum ENDP


end
