TITLE "Sorts an array of items"

.686
.model flat	            ; memory model
option casemap:none	    ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
; (none)


.code
;----------------------------------------------------------------------------
; A insertion sort method when sorting less then or equal to 8 elements
; Called from the Quicksort routine.
;============================================================================
_TEXT	SEGMENT
_comp$ = 8	; size = 4

align 16
_shortsort@4 PROC private
	push	ebp
	mov	ebp, ecx
	push	edi
	mov	edi, eax
	cmp	edi, ebp
	jbe	SHORT $L564
	push	ebx
	push	esi
	
align 4
$L563:
	lea	esi, DWORD PTR [ebp+4]
	cmp	esi, edi
	mov	ebx, ebp
	ja	SHORT $L569
	
align 16
$L567:
	push	ebx
	push	esi
	call	DWORD PTR _comp$[esp+20]
	test	eax, eax
	cmovg	ebx, esi
	add	esi, 4
	cmp	esi, edi
	jbe	SHORT $L567

$L569:
	cmp	ebx, edi
	je	SHORT $L638

	mov	eax, DWORD PTR [ebx]
	mov	ecx, DWORD PTR [edi]
	mov	DWORD PTR [ebx], ecx
	mov	DWORD PTR [edi], eax

$L638:
	sub	edi, 4
	cmp	edi, ebp
	ja	SHORT $L563
	pop	esi
	pop	ebx

$L564:
	pop	edi
	pop	ebp
	ret	4
_shortsort@4 ENDP
_TEXT	ENDS



;-----------------------------------------------------------------------------
; prototype:
;    void __stdcall QuickSort(void** array, int count, int (__stdcall *comp)(const void *, const void *));
;
; Description:
;   Sorts an array of 'Count' elements. The argument Array is a pointer to the
;   base of the array to be sorted. The argument 'compare' is a pointer to a
;   user-defined compare routine which compares two array elements.
;
; Returns:
;   (no value)
;=============================================================================
_TEXT	SEGMENT
_stkptr$ = -244	; size = 4
_lostk$ = -240		; size = 120
_histk$ = -120		; size = 120
_base$ = 8			; size = 4
_num$ = 12			; size = 4
_comp$ = 16			; size = 4

align 16
_QuickSort@12 PROC public
	mov	eax, DWORD PTR _num$[esp-4]
	sub	esp, 244
	cmp	eax, 2
	jb	$L622

	push	ebp
	push	esi
	mov	esi, DWORD PTR _base$[esp+248]
	push	ebx
	mov	DWORD PTR _stkptr$[esp+256], 0
	lea	ebp, DWORD PTR [esi+eax*4-4]
	push	edi
	
align 4
Recursive:
	mov	eax, ebp
	sub	eax, esi
	shr	eax, 2
	add	eax, 1
	cmp	eax, 8
	ja	SHORT $L595

	push	DWORD PTR _comp$[esp+256]
	mov	ecx, esi
	mov	eax, ebp
	call	_shortsort@4
	
$L672:
	sub	DWORD PTR _stkptr$[esp+260], 1
	js	$L675

	mov	eax, DWORD PTR _stkptr$[esp+260]
	mov	esi, DWORD PTR _lostk$[esp+eax*4+260]
	mov	ebp, DWORD PTR _histk$[esp+eax*4+260]
	jmp	SHORT Recursive
	
align 4
$L595:
	and	al, -2
	lea	eax, DWORD PTR [esi+eax*2]
	cmp	eax, esi
	je		SHORT $L649

	mov	ecx, DWORD PTR [eax]
	mov	edx, DWORD PTR [esi]
	mov	DWORD PTR [eax], edx
	mov	DWORD PTR [esi], ecx

$L649:
	mov	ebx, esi
	lea	edi, DWORD PTR [ebp+4]

align 4
$L601:
	add	ebx, 4
	cmp	ebx, ebp
	ja	SHORT $L606

	push	esi
	push	ebx
	call	DWORD PTR _comp$[esp+264]
	test	eax, eax
	jle	SHORT $L601
	
align 4
$L606:
	sub	edi, 4
	cmp	edi, esi
	jbe	SHORT $L610

	push	esi
	push	edi
	call	DWORD PTR _comp$[esp+264]
	test	eax, eax
	jge	SHORT $L606
	
$L610:
	cmp	ebx, edi
	ja	SHORT $L670
	je	SHORT $L601

	mov	eax, DWORD PTR [ebx]
	mov	ecx, DWORD PTR [edi]
	mov	DWORD PTR [ebx], ecx
	mov	DWORD PTR [edi], eax
	jmp	SHORT $L601
	
align 4
$L670:
	cmp	esi, edi
	je	SHORT $L659

	mov	eax, DWORD PTR [esi]
	mov	edx, DWORD PTR [edi]
	mov	DWORD PTR [esi], edx
	mov	DWORD PTR [edi], eax

$L659:
	mov	ecx, ebp
	mov	eax, edi
	sub	eax, esi
	sub	eax, 1
	sub	ecx, ebx
	cmp	eax, ecx
	jl	SHORT $L612

	lea	edx, DWORD PTR [esi+4]
	cmp	edx, edi
	jae	SHORT $L614

	mov	eax, DWORD PTR _stkptr$[esp+260]
	add	DWORD PTR _stkptr$[esp+260], 1
	add	edi, -4
	mov	DWORD PTR _lostk$[esp+eax*4+260], esi
	mov	DWORD PTR _histk$[esp+eax*4+260], edi

$L614:
	cmp	ebx, ebp
	jae	$L672

	mov	esi, ebx
	jmp	Recursive
	
align 4
$L612:
	cmp	ebx, ebp
	jae	SHORT $L618

	mov	eax, DWORD PTR _stkptr$[esp+260]
	add	DWORD PTR _stkptr$[esp+260], 1
	mov	DWORD PTR _lostk$[esp+eax*4+260], ebx
	mov	DWORD PTR _histk$[esp+eax*4+260], ebp

$L618:
	lea	eax, DWORD PTR [esi+4]
	cmp	eax, edi
	jae	$L672

	lea	ebp, DWORD PTR [edi-4]
	jmp	Recursive
	
align 4
$L675:
	pop	edi
	pop	ebx
	pop	esi
	pop	ebp

$L622:
	add	esp, 244
	ret	12

_QuickSort@12 ENDP
_TEXT	ENDS

END
