TITLE "Creates a 32-bit HASH value and uppercases any characters"

.586
.model flat, stdcall	; memory model
option casemap:none	    ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
; (none)


.const
align 16
UpperCase_Table DB 000H, 001H, 002H, 003H, 004H, 005H, 006H, 007H, 008H, 009H, 00aH, 00bH, 00cH, 00dH, 00eH, 00fH
   DB 010H, 011H, 012H, 013H, 014H, 015H, 016H, 017H, 018H, 019H, 01aH, 01bH, 01cH, 01dH, 01eH, 01fH
   DB 020H, 021H, 022H, 023H, 024H, 025H, 026H, 027H, 028H, 029H, 02aH, 02bH, 02cH, 02dH, 02eH, 02fH
   DB 030H, 031H, 032H, 033H, 034H, 035H, 036H, 037H, 038H, 039H, 03aH, 03bH, 03cH, 03dH, 03eH, 03fH
   DB 040H, 061H, 062H, 063H, 064H, 065H, 066H, 067H, 068H, 069H, 06aH, 06bH, 06cH, 06dH, 06eH, 06fH
   DB 070H, 071H, 072H, 073H, 074H, 075H, 076H, 077H, 078H, 079H, 07aH, 05bH, 05cH, 05dH, 05eH, 05fH
   DB 060H, 061H, 062H, 063H, 064H, 065H, 066H, 067H, 068H, 069H, 06aH, 06bH, 06cH, 06dH, 06eH, 06fH
   DB 070H, 071H, 072H, 073H, 074H, 075H, 076H, 077H, 078H, 079H, 07aH, 07bH, 07cH, 07dH, 07eH, 07fH
   DB 080H, 081H, 082H, 083H, 084H, 085H, 086H, 087H, 088H, 089H, 08aH, 08bH, 08cH, 08dH, 08eH, 08fH
   DB 090H, 091H, 092H, 093H, 094H, 095H, 096H, 097H, 098H, 099H, 09aH, 09bH, 09cH, 09dH, 09eH, 09fH
   DB 0a0H, 0a1H, 0a2H, 0a3H, 0a4H, 0a5H, 0a6H, 0a7H, 0a8H, 0a9H, 0aaH, 0abH, 0acH, 0adH, 0aeH, 0afH
   DB 0b0H, 0b1H, 0b2H, 0b3H, 0b4H, 0b5H, 0b6H, 0b7H, 0b8H, 0b9H, 0baH, 0bbH, 0bcH, 0bdH, 0beH, 0bfH
   DB 0c0H, 0c1H, 0c2H, 0c3H, 0c4H, 0c5H, 0c6H, 0c7H, 0c8H, 0c9H, 0caH, 0cbH, 0ccH, 0cdH, 0ceH, 0cfH
   DB 0d0H, 0d1H, 0d2H, 0d3H, 0d4H, 0d5H, 0d6H, 0d7H, 0d8H, 0d9H, 0daH, 0dbH, 0dcH, 0ddH, 0deH, 0dfH
   DB 0e0H, 0e1H, 0e2H, 0e3H, 0e4H, 0e5H, 0e6H, 0e7H, 0e8H, 0e9H, 0eaH, 0ebH, 0ecH, 0edH, 0eeH, 0efH
   DB 0f0H, 0f1H, 0f2H, 0f3H, 0f4H, 0f5H, 0f6H, 0f7H, 0f8H, 0f9H, 0faH, 0fbH, 0fcH, 0fdH, 0feH, 0ffH


.code
; ----------------------------------------------------------------------------
; prototype:
;   unsigned long __stdcall Hash32NoCase(const void* pBuffer, unsigned Len);
;
; Description:
;   Creates a simple 32-bit hash value from a case-insensitive string or
;   binary data.
;
; Returns:
;   A 32-bit hash value.
; ============================================================================
align 16
Hash32NoCase proc public uses ebx esi edi Buffer:dword, Len:dword
	; load our registers with the params
	mov	ecx, [Len]
	mov	esi, [Buffer]

	; start our value out at zero
	sub	ecx, 1
	xor	eax, eax
	xor	ebx, ebx
	

; equivalent c code of this loop
; n = 0;
; while (len--)
;		n = (n << 3) ^ n ^ HashTable[*pBuffer++];
; n &= 7fffffffH

align 4
@@:
	mov	bl, byte ptr [esi+ecx]
	mov	edi, eax
	shl	edi, 3

	movzx	edx, byte ptr UpperCase_Table[ebx]
	xor	edx, edi
	xor	eax, edx

	sub	ecx, 1
	jns	@B

	and	eax, 07fffffffH

	ret
Hash32NoCase ENDP

END
