TITLE "Converts a HBITMAP image to Grayscale"

.586
.model flat, stdcall
option casemap :none      ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
include Windows.inc
include Gdi32.inc


; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Graphics.inc


.code
align 16
; -----------------------------------------------------------------------------------------
; Prototype		:  void __stdcall GrayScaleFromHBITMAP(HBITMAP Bitmap);
;
; NOTE:
;   This function always assumes that the bitmap handle passed in will always be in
;   32-bit format (ARGB).
; -----------------------------------------------------------------------------------------
GrayScaleFromHBITMAP proc uses ebx esi edi hBitmap:DWORD
 
	LOCAL BMPInfo  : BITMAP
	LOCAL bmData	: BMBitsData
	
	invoke GetObject, [hBitmap], sizeof BMPInfo, ADDR BMPInfo

	; fill out the BitmapBitsInfo structure
	mov	ecx, [BMPInfo.bmWidth]
	mov	edx, [BMPInfo.bmHeight]
	mov 	eax, [BMPInfo.bmWidthBytes]
	mov	ebx, [hBitmap]
	mov	[bmData.ptDimensions.x], ecx
	mov	[bmData.ptDimensions.y], edx
	mov	[bmData.hBitmap], ebx
	mul	edx
	lea	ecx, bmData
	mov 	ebx, eax
	
	; get the raw pixel data now
	invoke GetBitmapData, ecx
 
	mov edi, [bmData.pBits]
	mov esi, [bmData.pBits]
	add edi, ebx
	
	align 4
	.while esi < edi
		movzx eax, byte ptr[esi]       ; blue
		movzx ecx, byte ptr[esi+1]     ; green
		movzx edx, byte ptr[esi+2]     ; red

		shl eax, 5
		shl ecx, 7
		shl edx, 6

		add eax, 128
		add eax, ecx
		add eax, edx
		
		mov byte ptr[esi], ah
		mov byte ptr[esi+1], ah
		mov byte ptr[esi+2], ah

		add esi, 4
	.endw

	invoke SetBitmapBits, [hBitmap], ebx, [bmData.pBits]
	invoke DeleteObject, [bmData.hDibSection]
	
	ret
GrayScaleFromHBITMAP endp

END
