TITLE "Draws a image on the DC using a HBITMAP handle"

.586
.model flat, stdcall      ; memory model & calling convention
option casemap :none      ; case sensitive


; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
include Windows.inc
include Gdi32.inc


; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------


.code
; -----------------------------------------------------------------------------------------
; Prototype		:  HBITMAP __stdcall bmpRenderImage(LPVOID bmData, LPSIZE lpSize);
; -----------------------------------------------------------------------------------------
align 16
bmpRenderImage proc public uses ebx esi edi bmData:dword, lpSize:dword

	LOCAL	csSize		:SIZEL
	LOCAL	DibBitmap	:dword	; HBITMAP
	LOCAL	hMemDC		:dword	; HDC
	LOCAL	hMemBitmap	:dword	; HBITMAP
	LOCAL	hOldBitmap	:dword	; HBITMAP

	; BITMAPFILEHEADER* pbmFileHdr = (BITMAPFILEHEADER*)pImage;
	; BITMAPINFO* pbmInfo = (BITMAPINFO*)((LPBYTE)pImage + sizeof(BITMAPFILEHEADER));
	; LPVOID lpBits = ((LPBYTE)pImage + pbmFileHdr->bfOffBits);
	mov	edi, [bmData]
	invoke GetDC, NULL
	lea	esi, [edi + sizeof BITMAPFILEHEADER]
	add	edi, [edi].BITMAPFILEHEADER.bfOffBits
	mov	ebx, eax
		
	invoke CreateDIBitmap, eax, esi, CBM_INIT, edi, esi, DIB_RGB_COLORS
	mov	[DibBitmap], eax

	; change our rendered width and/or height if we are suppose to	
	mov	eax, [lpSize]
	test	eax, eax
	jne	short @F
	
	invoke ReleaseDC, eax, ebx
	mov	eax, [DibBitmap]
	ret

align 4
@@:
	; int CX = pbmInfo->bmiHeader.biWidth;
	; int CY = pbmInfo->bmiHeader.biHeight;
	mov	ecx, [esi].BITMAPINFO.bmiHeader.biWidth
	mov	edx, [esi].BITMAPINFO.bmiHeader.biHeight

	mov	[csSize.x], ecx
	mov	[csSize.y], edx

	mov	ecx, [eax].SIZEL.x
	mov	edx, [eax].SIZEL.y

	cmp	ecx, -1
	je		short @F
	mov	[csSize.x], ecx
	
@@:
	cmp	edx, -1
	je		short @F
	mov	[csSize.y], edx

@@:
	invoke CreateCompatibleDC, NULL
	mov	[hMemDC], eax	

	invoke SetStretchBltMode, eax, COLORONCOLOR
	
	invoke CreateCompatibleBitmap, ebx, [csSize.x], [csSize.y]
	mov	[hMemBitmap], eax

	invoke SelectObject, [hMemDC], eax
	mov	[hOldBitmap], eax
	
	invoke StretchDIBits, [hMemDC], 0, 0, [csSize.x], [csSize.y], 0, 0, [esi].BITMAPINFO.bmiHeader.biWidth, [esi].BITMAPINFO.bmiHeader.biHeight, edi, esi, DIB_RGB_COLORS, SRCCOPY 
	invoke SelectObject, [hMemDC], [hOldBitmap]
	invoke DeleteObject, [DibBitmap]
	invoke DeleteDC, [hMemDC]
	invoke ReleaseDC, NULL, ebx
	
	mov	eax, [hMemBitmap]

	ret
bmpRenderImage endp

END
