TITLE ""

.586
.model flat, stdcall			; memory model
option casemap :none			; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
include Windows.inc
include User32.inc


; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include menu.inc

.code

align 16
GetMenuBarTextWidth proc public uses ebx esi edi hMenu:HMENU
	LOCAL mmi		:MENUITEMINFO
	LOCAL nWidth	:dword

	mov	ebx, [hMenu]
	mov	dword ptr [nWidth], 0

	; make sure we have a valid menu handle passed in
	test ebx, ebx
	je short Result

	; find out how many menu items are available
	push ebx
	call GetMenuItemCount
	mov	esi, eax

	; initialize the required values of the MENUITEMINFO structure
	; to get our menu item's data
	mov	[mmi.cbSize], sizeof MENUITEMINFO
	mov	[mmi.fMask], MIIM_DATA

	; get the space required for any check marks -- even though
	; the main menu bar doesn't draw them, we still calculated
	; the value into it when we created the user-data and placed
	; it in the item's data variable.
	push SM_CXMENUCHECK
	call GetSystemMetrics
	sub	eax, 1

	; set up a loop from the end-1 to zero	
	add	esi, -1
	mov	edi, eax
	js short Result

align 4
@@:
	; get our menu's item data so we can find out how long the text
	; length is since we have made it owner-drawn with a font.
	lea eax, [mmi]
	mov ecx, 1
	push eax
	push ecx
	push esi
	push ebx
	call GetMenuItemInfo
	
	; add to our width the length of the SM_CXMENUCHECK value along
	; with the item's data length for the specified menu item
	mov	ecx, [mmi.dwItemData]
	add	[nWidth], edi
	mov	edx, [ecx+8]
	add	[nWidth], edx
	
	; loop to the next item
	sub	esi, 1
	jns	short @B

Result:
	mov	eax, [nWidth]

	ret	4
GetMenuBarTextWidth endp

END
