TITLE ""

.586
.model flat, stdcall      ; memory model & calling convention
option casemap :none      ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
include Windows.inc
include User32.inc
include Gdi32.inc

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Graphics.inc
include Menu.inc


.code

; ----------------------------------------------------------------------------
; prototype:
;		void __stdcall DrawMenuCheckmark(HDC hDC);
;
; Description:
;
;
; Returns:
;   (none)
; ============================================================================
align 16
DrawMenuCheckmark proc uses ebx hDC:dword
    local   Rectcm  : RECTL
    local   hOldObj : dword
    local   hBitmap : dword

    ; set up the rect structure
    xor eax, eax
    mov [Rectcm.top], eax
    mov [Rectcm.left], eax
    
    push SM_CXMENUCHECK
    call GetSystemMetrics
    mov [Rectcm.right], eax
    
    push SM_CYMENUCHECK
    call GetSystemMetrics
    mov [Rectcm.bottom], eax

    ; create a compatible DC object
    push [hDC]
    call CreateCompatibleDC
    mov ebx, eax
    
    ; create our bitmap based on the rect size    
    push [Rectcm.bottom]
    push [Rectcm.right]
    push ebx
    call CreateCompatibleBitmap
    mov [hBitmap], eax

    ; select this bitmap into our source DC
    push eax
    push ebx
    call SelectObject
    mov [hOldObj], eax
    
    ; draw the frame control with correct size
    lea ecx, [Rectcm]
    push DFCS_MENUCHECK
    push DFC_MENU
    push ecx
    push ebx
    call DrawFrameControl

    ; restore the bitmap in the DC object            
    push [hOldObj]
    push ebx
    call SelectObject

    ; delete the DC object now that we are done with it
    push ebx
    call DeleteObject
    
    ; draw this bitmap onto the destination DC and transparently
    lea eax, [Rectcm]
    push 1  ; use 1st pixel
    push 0  ; no COLORREF ptr
    push eax
    push [hBitmap]
    push [hDC]
    call DrawTransparentBitmap

    ; free our bitmap object
    push [hBitmap]
    call DeleteObject
                   
    ret
DrawMenuCheckmark endp

END
