TITLE ""

.586
.model flat, stdcall      ; memory model & calling convention
option casemap :none      ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
include Windows.inc
include User32.inc
include Gdi32.inc

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Memory.inc
include asm_Strings.inc
include Menu.inc


.code

; ----------------------------------------------------------------------------
; prototype:
;		void __stdcall DrawMenuText(IN DRAWITEMSTRUCT* lpms);
;
; Description:
;
;
; Returns:
;   (none)
; ============================================================================
DrawMenuText proc uses ebx esi edi item:dword ; DRAWITEMSTRUCT
    LOCAL pwszString        : dword
    LOCAL pTabChar          : dword

IF _UNICODE eq 1
    LOCAL wszStrLeft[256]   : word
    LOCAL wszStrRight[256]  : word
ELSE
    LOCAL wszStrLeft[256]   : byte
    LOCAL wszStrRight[256]  : byte
ENDIF

    ; find out if this the mainmenu or a sub-menu.
    mov esi, [item]
    mov edi, [esi].DRAWITEMSTRUCT.itemData
    cmp [edi].MenuItem.bMainMenu, TRUE
    mov ebx, (DT_SINGLELINE or DT_VCENTER or DT_NOCLIP or DT_CENTER)
    jne short SubMenuText

    ; Main menu text -- just draw it straight
TextWithNoTab:
    lea edx, [esi].DRAWITEMSTRUCT.rcItem
    lea eax, [edi].MenuItem.szItemText
	push ebx
	push edx
    push -1     ; let DrawTextW calc length of string
    push eax
    push [esi].DRAWITEMSTRUCT.hDC
    call DrawText
    ret    
    
SubMenuText:
    ; get the width of a SM_CXMENUCHECK
    push SM_CXMENUCHECK
	call GetSystemMetrics
        
    ; see if this menu-item has a \t character. If not, we can just
    ; draw it straight like the main menu
    lea edx, [edi].MenuItem.szItemText
    add [esi].DRAWITEMSTRUCT.rcItem.left, eax ; don't put right on edge    
    push 9  ; '\t' character
    push edx
    mov [pwszString], edx
    call strChar
    test eax, eax
    mov ebx, (DT_SINGLELINE or DT_VCENTER or DT_NOCLIP or DT_LEFT)
    je short TextWithNoTab

    ; we have a sub-menu with two parts that we need to draw.
    ; 1st part is all text before the '\t' character and left justified
    ; 2nd part is all text after the '\t' character and right justified
    mov [pTabChar], eax

    ; clear out our two part buffers    
    lea edx, [wszStrLeft]
    push sizeof wszStrLeft
    push edx
    call fmClear
    
    lea edx, [wszStrRight]
    push sizeof wszStrRight
    push edx
    call fmClear
    
    ; copy the left part into the working buffer to be displayed
    mov ecx, [pTabChar]
    sub ecx, [pwszString]
    lea edx, [wszStrLeft]        
    push ecx
    push [pwszString]
    push edx
    call fmCopy    

    ; copy the right part into the working buffer to be displayed
IF _UNICODE eq 1
    add [pTabChar], 2  ; skip past the '\t\0' chars
ELSE
    add [pTabChar], 1  ; skip past the '\t\0' chars
ENDIF
    lea edx, [wszStrRight]
    push [pTabChar]
    push edx
    call strCopy

    ; draw the left part
    lea ecx, [esi].DRAWITEMSTRUCT.rcItem.left
    lea edx, [wszStrLeft]
	push (DT_SINGLELINE or DT_VCENTER or DT_NOCLIP or DT_LEFT)
	push ecx
    push -1     ; let DrawTextW calc length of string
    push edx
    push [esi].DRAWITEMSTRUCT.hDC
    call DrawText

    ; and finally, draw the right part
    lea ecx, [esi].DRAWITEMSTRUCT.rcItem.left
    lea edx, [wszStrRight]
    sub [esi].DRAWITEMSTRUCT.rcItem.right, 4    ; don't put right on edge
	push (DT_SINGLELINE or DT_VCENTER or DT_NOCLIP or DT_RIGHT)
	push ecx
    push -1     ; let DrawTextW calc length of string
    push edx
    push [esi].DRAWITEMSTRUCT.hDC
    call DrawText
            
    ret
DrawMenuText endp

END
