TITLE ""

.586
.model flat, stdcall			; memory model
option casemap :none			; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
include Windows.inc
include Gdi32.inc
include User32.inc


; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include menu.inc


.code

align 16
MeasureMenuItem proc public uses ebx esi edi lpms:DWORD ;MEASUREITEMSTRUCT<>
	LOCAL rect	 	: RECTL
	LOCAL cxMenu 	: dword
	LOCAL cyMenu 	: dword
	LOCAL fmtType	: dword
	LOCAL fntOld	: HFONT
	
	; set up our starting width and height of a menu item.
	mov	ebx, [lpms]
	mov	dword ptr [cxMenu], 0
	mov	edi, [ebx].MEASUREITEMSTRUCT.itemData
	
	push SM_CYMENU
	call GetSystemMetrics
	mov	[cyMenu], eax	

	; are we processing a menu item (text, sub-menu) or a seperator?
	xor	ecx, ecx
	cmp	[ebx].MEASUREITEMSTRUCT.itemID, 0
	je MenuSeperator
	
	; ----------------------------------------------------------------------------	
	; this section is dealing with a menu item which has text and/or is a sub-menu
	; ----------------------------------------------------------------------------
	cmp	[edi].MenuItem.bMainMenu, ecx
	mov	[rect.left], ecx
	mov	[rect.top], ecx
	mov	[rect.right], ecx
	mov	[rect.bottom], ecx
	mov	[fmtType], DT_SINGLELINE or DT_LEFT or DT_VCENTER or DT_CALCRECT	
	jne	short @F

	or [fmtType], DT_EXPANDTABS
	push SM_CXMENUCHECK
	call GetSystemMetrics
	add	eax, eax
	mov	[cxMenu], eax
		
@@:
    push NULL
    call GetDC
	mov	esi, eax
	
	push [edi]
	push eax
	call SelectObject
	mov	[fntOld], eax
	
	mov	ecx, [fmtType]
	lea	edx, rect
	lea	eax, [edi].MenuItem.szItemText
	push ecx
	push edx
	push [edi].MenuItem.cchItemText
	push eax
	push esi
	call DrawText

    push [fntOld]
    push esi
    call SelectObject
    
    push esi
    push NULL
    call ReleaseDC

	mov	eax, [rect.bottom]
	mov	edx, [rect.right]
	sub	eax, [rect.top]
	sub	edx, [rect.left]

	cmp	[cyMenu], eax
	jle	short @F
	mov	eax, [cyMenu]
	
@@:
	add	[cxMenu], edx
	mov	[ebx].MEASUREITEMSTRUCT.itemHeight, eax
	jmp	short @F
		
MenuSeperator:
	mov	eax, [cyMenu] 
	sar	eax, 1
	mov	[ebx].MEASUREITEMSTRUCT.itemHeight, eax

@@:
	mov	ecx, [cxMenu]
	mov	[edi].MenuItem.csSize.y, eax

	mov	[ebx].MEASUREITEMSTRUCT.itemWidth, ecx
	mov	[edi].MenuItem.csSize.x, ecx
	
	ret
MeasureMenuItem endp

END
