TITLE "checks to see if all parameters are valid"

.586
.model flat			; memory model
option casemap:none	; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_faArray.inc


.code

; ----------------------------------------------------------------------------
; prototype:
; LONG __stdcall faCheckParameters(ArrayObject*, const LONG index, BOOL CheckIdx);
; ----------------------------------------------------------------------------
align 16
_faCheckParameters@12 proc public
	; load our registers with the parameters
	mov	eax, [esp+4]
	mov	ecx, [esp+8]
	mov	edx, [esp+12]
	
	; make sure our object isn't a NULL pointer
	test	eax, eax
	jne	@F
	
	; it is, so return error result
	or	eax, AO_PARAMS_INVALID
	ret 12
	
@@:
	; chech to see if the array member is NULL
	cmp	[eax].ArrayObject.Array, 0
	jne	@F
	
	; it is, so return error result
	mov	eax, AO_CREATE_FIRST
	ret 12

@@:
	; check to see if we are suppose to check the bounds of the "index" param
	cmp	edx, 0
	je		Done
	
	; check the bounds of the "index" param
	test	ecx, ecx
	jl		@F
	cmp	ecx, [eax].ArrayObject.Count
	jl		Done

@@:
	mov	eax, AO_INDEX_OUT_OF_RANGE
	ret 12	

Done:
	xor	eax, eax	; AO_SUCCESS
	ret 12
_faCheckParameters@12 ENDP

END
