TITLE "Create a new array object"

.586
.model flat			; memory model
option casemap:none	; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Memory.inc
include asm_faArray.inc


.code

; ----------------------------------------------------------------------------
; prototype:
; LONG __stdcall faCreate(ArrayObject* pObject);
; ----------------------------------------------------------------------------
align 16
_faCreate@4 proc public
	; get our parameter into a register to test
	mov ecx, [esp+4]
	
	; set the return value in case the parameter is a NULL pointer
	mov eax, AO_PARAMS_INVALID

	; make sure our parameter isn't a NULL pointer
	test ecx, ecx
	je short @F
	
	; allocate our array pointer buffer
	push AO_ALLOC_SIZE * sizeof DWORD	; num of elems * sizeof(LPVOID)
	call fmAlloc
	
	; save the address and basic array data
	mov	ecx, [esp+4]
	mov	[ecx].ArrayObject.Array, eax
	mov	[ecx].ArrayObject.AllocSize, AO_ALLOC_SIZE
	xor	eax, eax
	mov	[ecx].ArrayObject.Count, eax

@@:
	ret 4
_faCreate@4 ENDP

END
