TITLE "Destroy the array and all objects in array"

.586
.model flat			; memory model
option casemap:none	; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Memory.inc
include asm_faArray.inc


.code

; ----------------------------------------------------------------------------
; prototype:
; void __stdcall faDestroy(ArrayObject* pObject);
; ----------------------------------------------------------------------------
align 16
_faDestroy@4 proc public
	; using ESI register so we can keep the parameter in a register
	push esi
	
	; make sure our parameter isn't a NULL pointer
	mov	esi, [esp+8]
	test esi, esi
	je short Done
	
	; see if the Array variable of the object is NULL
	mov	eax, [esi].ArrayObject.Array
	test eax, eax
	je short @F
	
	; free our array allocation	
	push eax
	call fmFree
	
@@:
	; clear our the object member variables passed in
	xor	eax, eax
	mov	[esi].ArrayObject.Array, eax
	mov	[esi].ArrayObject.AllocSize, eax
	mov	[esi].ArrayObject.Count, eax
	
Done:
	pop	esi
	ret	4
_faDestroy@4 ENDP

END
