TITLE "Get the index value based on pointer comparison"

.586
.model flat			; memory model
option casemap:none	; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_faArray.inc


.code
; ----------------------------------------------------------------------------
; prototype:
; LONG __stdcall faGetIndexByElement(ArrayObject* Object, LPCVOID pElement);
; ----------------------------------------------------------------------------
align 16
_faGetIndexByElement@8 proc public
	; save the ESI register
	push	esi
	mov	esi, [esp+8]
	
	; check our params
	xor	eax, eax
	push	eax
	push	eax
	push	esi
	call  faCheckParameters

	; set up for searching (usually the loop will always be executed).
	mov	ecx, [esi].ArrayObject.Array
	mov	edx, [esp+12]

	; check the return value
	test	eax, eax
	je FindLoop
	
	; failed result, so return it
	pop	esi
	ret 8
	
	; search for the element address in our array
align 4
FindLoop:
	cmp	[ecx], edx
	je		Done
	
	; advance to next element in array
	add	eax, 1
	add	ecx, 4
	cmp	eax, [esi].ArrayObject.Count
	jl		FindLoop
	
	; not found, set return status
	mov	eax, AO_NOTFOUND
	
Done:
	pop	esi
	ret	8
_faGetIndexByElement@8 ENDP

END
