TITLE "Entry procedure for a DLL"

.486
.model flat
option casemap :none      ; case sensitive

extern __imp__DisableThreadLibraryCalls@4:near

.code
align 16
; ----------------------------------------------------------------------------
; prototype:
;   BOOL DllMain(HINSTANCE hInstance, DWORD dwReason, DWORD reserved);
;
; description:
;	Initial entry point for a DLL
;
;	There are four values you could process with 'dwReason'.
;		DLL_PROCESS_ATTACH, DLL_PROCESS_DETACH,
;		DLL_THREAD_ATTACH and DLL_THREAD_DETACH
;
; returns:
;	During the DLL_PROCESS_ATTACH, 1 = success, 0 = failure
;	any other time, just return 1 in EAX
;
; ----------------------------------------------------------------------------
; Stack and parameter ESP offsets (these values don't take any pushes during
; the function call into account).
; 
; ESP +  4 = hInstance parameter 
; ESP +  8 = dwReason parameter
; ESP + 12 = reserved parameter
; ============================================================================
_DllMain@12 proc near
   ; set our return value to TRUE
	mov eax, 1
	
	cmp dword ptr [esp + 8], 1	; DLL_PROCESS_ATTACH
	jne @F
	
	; during first time initialization (DLL_PROCESS_ATTACH), do the following

	; Disabling the DLL_THREAD_ATTACH and DLL_THREAD_DETACH notification calls
	; can be a useful optimization for multithreaded applications that have many
	; DLLs which frequently create and delete threads, and whose DLLs do not need
	; the thread-level notifications of attachment/detachment.

	push [esp + 4]	 ; instance handle
	call dword ptr __imp__DisableThreadLibraryCalls@4

	; since we called the DisableThreadLibraryCalls function, the return from
	; that function will be our return value from this function. If the function
	; failed, we'll signal that the loading of this DLL failed even though we
	; really can continue on.
	
@@:
	ret 12	
_DllMain@12 endp

END _DllMain@12
