; ****************************************************************************
;   This file contains all defines (equates), structures and ANSI/UNICODE
;   function prototypes for the WinOS ComCtl32.DLL. ANSI or UNICODE specific
;   function prototypes are defined in their respective .INC file.
;
;   You may use or modify this code freely without any restrictions.
;
;   v1.0 - Initial coding of the file   Oct 10, 2006  4:00 PM
; ****************************************************************************

; ----------------------------------------------------------------------------
; WinOS ComCtl32.DLL library specific defines and global variables
; ============================================================================


; ----------------------------------------------------------------------------
; INITCOMMONCONTROLSEX structure definition
; ============================================================================
INITCOMMONCONTROLSEX STRUCT
  cbSize		dword ?		; must be set to the size of INITCOMMONCONTROLSEX
  styles		dword ?		; class styles to use. to use all, set as 3fffh
INITCOMMONCONTROLSEX ENDS


; ----------------------------------------------------------------------------
; INITCOMMONCONTROLSEX common class definitions
; ============================================================================
ICC_LISTVIEW_CLASSES					equ 1 ; listview, header
ICC_TREEVIEW_CLASSES					equ 2 ; treeview, tooltips
ICC_BAR_CLASSES						equ 4 ; toolbar, statusbar, trackbar, tooltips
ICC_TAB_CLASSES						equ 8 ; tab, tooltips
ICC_UPDOWN_CLASS						equ 10h ; updown
ICC_PROGRESS_CLASS					equ 20h ; progress
ICC_HOTKEY_CLASS						equ 40h ; hotkey
ICC_ANIMATE_CLASS						equ 80h ; animate
ICC_WIN95_CLASSES						equ 0FFh
ICC_DATE_CLASSES						equ 100h ; month picker, date picker, time picker, updown
ICC_USEREX_CLASSES					equ 200h ; comboex
ICC_COOL_CLASSES						equ 400h	; rebar (coolbar) control
ICC_INTERNET_CLASSES					equ 800h
ICC_PAGESCROLLER_CLASS				equ 1000h	; page scroller
ICC_NATIVEFNTCTL_CLASS				equ 2000h	; native font control

ICC_DEFAULT_CLASSES					equ 3fffh ; all classes ORed together



; ----------------------------------------------------------------------------
; Function definitions --- ANSI/UNICODE non-specific
; ============================================================================
externdef stdcall InitCommonControlsEx		:proto stdcall :dword


; ----------------------------------------------------------------------------
; Function definitions used in the WinOS ComCtl32.DLL --- ANSI or UNICODE based
; on define during assembling
; ============================================================================
IF _UNICODE eq 1	; same definition as the MFC library (windows API uses UNICODE)
	include unicode\ComCtl32.inc
ELSE
	include ansi\ComCtl32.inc
ENDIF
