; ****************************************************************************
;   This file contains all defines (equates), structures and ANSI/UNICODE
;   function prototypes for the WinOS Gdi32.DLL. ANSI or UNICODE specific
;   function prototypes are defined in their respective .INC file.
;
;   You may use or modify this code freely without any restrictions.
;
;   v1.0 - Initial coding of the file   Oct 10, 2006  4:00 PM
; ****************************************************************************

; ----------------------------------------------------------------------------
; WinOS Gdi32.DLL library specific defines and global variables
; ============================================================================
SRCCOPY			equ 00CC0020h	; dest = source
SRCPAINT			equ 00EE0086h ; dest = source OR dest
SRCAND			equ 008800C6h ; dest = source AND dest
SRCINVERT		equ 00660046h ; dest = source XOR dest
SRCERASE			equ 00440328h ; dest = source AND (NOT dest )
NOTSRCCOPY		equ 00330008h ; dest = (NOT source)
NOTSRCERASE		equ 001100A6h ; dest = (NOT src) AND (NOT dest)
MERGECOPY		equ 00C000CAh ; dest = (source AND pattern)
MERGEPAINT		equ 00BB0226h ; dest = (NOT source) OR dest
PATCOPY			equ 00F00021h ; dest = pattern
PATPAINT			equ 00FB0A09h ; dest = DPSnoo
PATINVERT		equ 005A0049h ; dest = pattern XOR dest
DSTINVERT		equ 00550009h ; dest = (NOT dest)
BLACKNESS		equ 00000042h ; dest = BLACK
WHITENESS		equ 00FF0062h ; dest = WHITE
NOMIRRORBITMAP	equ 80000000h ; Do not Mirror the bitmap in this call
CAPTUREBLT		equ 40000000h ; Include layered windows

GDI_ERROR		equ FFFFFFFFh
HGDI_ERROR		equ FFFFFFFFh

; Region Flags
ERROR				equ 0h
NULLREGION		equ 1h
SIMPLEREGION	equ 2h
COMPLEXREGION	equ 3h
RGN_ERROR 		equ ERROR
RDH_RECTANGLES	equ 1h

; CombineRgn() Styles
RGN_AND		equ 1h
RGN_OR		equ 2h
RGN_XOR		equ 3h
RGN_DIFF		equ 4h
RGN_COPY		equ 5h
RGN_MIN		equ RGN_AND
RGN_MAX		equ RGN_COPY

; StretchBlt() Modes
BLACKONWHITE			equ 1h
WHITEONBLACK			equ 2h
COLORONCOLOR			equ 3h
HALFTONE					equ 4h
MAXSTRETCHBLTMODE		equ 4h
STRETCH_ANDSCANS		equ BLACKONWHITE
STRETCH_ORSCANS		equ WHITEONBLACK
STRETCH_DELETESCANS	equ COLORONCOLOR
STRETCH_HALFTONE		equ HALFTONE

; PolyFill() Modes
ALTERNATE		equ 1h
WINDING			equ 2h
POLYFILL_LAST	equ 2h

; Layout Orientation Options
LAYOUT_RTL									equ 00000001h ; Right to left
LAYOUT_BTT									equ 00000002h ; Bottom to top
LAYOUT_VBH									equ 00000004h ; Vertical before horizontal
LAYOUT_ORIENTATIONMASK					equ (LAYOUT_RTL or LAYOUT_BTT or LAYOUT_VBH)
LAYOUT_BITMAPORIENTATIONPRESERVED	equ 00000008h

; Text Alignment Options
TA_NOUPDATECP	equ 0h
TA_UPDATECP		equ 1h

TA_LEFT			equ 0h
TA_RIGHT			equ 2h
TA_CENTER		equ 6h

TA_TOP			equ 0h
TA_BOTTOM		equ 8h
TA_BASELINE		equ 18h
TA_RTLREADING	equ 100h
TA_MASK			equ (TA_BASELINE and TA_CENTER and TA_UPDATECP and TA_RTLREADING)

VTA_BASELINE	equ TA_BASELINE
VTA_LEFT			equ TA_BOTTOM
VTA_RIGHT		equ TA_TOP
VTA_CENTER		equ TA_CENTER
VTA_BOTTOM		equ TA_RIGHT
VTA_TOP			equ TA_LEFT

ETO_OPAQUE				equ 2h
ETO_CLIPPED				equ 4h
ETO_GLYPH_INDEX		equ 10h
ETO_RTLREADING			equ 80h
ETO_NUMERICSLOCAL		equ 400h
ETO_NUMERICSLATIN		equ 800h
ETO_IGNORELANGUAGE	equ 1000h
ETO_PDY					equ 2000h

ASPECT_FILTERING		equ 1h

; Bounds Accumulation APIs

DCB_RESET			equ 1h
DCB_ACCUMULATE		equ 2h
DCB_DIRTY			equ DCB_ACCUMULATE
DCB_SET				equ (DCB_RESET or DCB_ACCUMULATE)
DCB_ENABLE			equ 4h
DCB_DISABLE			equ 8h

DIB_RGB_COLORS				equ 0h
DIB_PAL_COLORS				equ 1h
DIB_PAL_INDICES			equ 2h
DIB_PAL_PHYSINDICES		equ 2h
DIB_PAL_LOGINDICES		equ 4h

CBM_CREATEDIB		equ 2h
CBM_INIT				equ 4h


; ----------------------------------------------------------------------------
; DrawText() Format Flags
; ============================================================================
DT_TOP                  equ 0h
DT_LEFT                 equ 0h
DT_CENTER               equ 1h
DT_RIGHT                equ 2h
DT_VCENTER              equ 4h
DT_BOTTOM               equ 8h
DT_WORDBREAK            equ 10h
DT_SINGLELINE           equ 20h
DT_EXPANDTABS           equ 40h
DT_TABSTOP              equ 80h
DT_NOCLIP               equ 100h
DT_EXTERNALLEADING      equ 200h
DT_CALCRECT             equ 400h
DT_NOPREFIX             equ 800h
DT_INTERNAL             equ 1000h
DT_EDITCONTROL          equ 2000h
DT_PATH_ELLIPSIS        equ 4000h
DT_END_ELLIPSIS         equ 8000h
DT_MODIFYSTRING         equ 10000h
DT_RTLREADING           equ 20000h
DT_WORD_ELLIPSIS        equ 40000h
DT_NOFULLWIDTHCHARBREAK	equ 80000h
DT_HIDEPREFIX           equ 100000h
DT_PREFIXONLY           equ 200000h


; DRAWTEXTPARAMS structure definition
DRAWTEXTPARAMS STRUCT
	cbSize			dword ?
	iTabLength		dword ?
	iLeftMargin		dword ?
	iRightMargin	dword ?
	uiLenghtDrawn	dword ?
DRAWTEXTPARAMS ENDS


; ----------------------------------------------------------------------------
; structures used
; ----------------------------------------------------------------------------
RGNDATAHEADER STRUCT
  dwSize    dword ?
  iType     dword ?
  nCount    dword ?
  nRgnSize  dword ?
  rcBound   RECTL <>
RGNDATAHEADER ENDS

RGNDATA STRUCT
  rdh       RGNDATAHEADER <>
  Buffer    byte ?
RGNDATA ENDS

BITMAP STRUCT
  bmType        DWORD       ?
  bmWidth       DWORD       ?
  bmHeight      DWORD       ?
  bmWidthBytes  DWORD       ?
  bmPlanes      WORD        ?
  bmBitsPixel   WORD        ?
  bmBits        DWORD       ?
BITMAP ENDS

RGBTRIPLE STRUCT
  rgbtBlue      BYTE      ?
  rgbtGreen     BYTE      ?
  rgbtRed       BYTE      ?
RGBTRIPLE ENDS

RGBQUAD STRUCT
  rgbBlue       BYTE      ?
  rgbGreen      BYTE      ?
  rgbRed        BYTE      ?
  rgbReserved   BYTE      ?
RGBQUAD ENDS

BITMAPCOREHEADER STRUCT
  bcSize        DWORD      ?
  bcWidth       WORD      ?
  bcHeight      WORD      ?
  bcPlanes      WORD      ?
  bcBitCount    WORD      ?
BITMAPCOREHEADER ENDS

BITMAPINFOHEADER STRUCT
  biSize            DWORD      ?
  biWidth           DWORD      ?
  biHeight          DWORD      ?
  biPlanes          WORD       ?
  biBitCount        WORD       ?
  biCompression     DWORD      ?
  biSizeImage       DWORD      ?
  biXPelsPerMeter   DWORD      ?
  biYPelsPerMeter   DWORD      ?
  biClrUsed         DWORD      ?
  biClrImportant    DWORD      ?
BITMAPINFOHEADER ENDS

BITMAPINFO STRUCT
  bmiHeader  BITMAPINFOHEADER <>
  bmiColors  RGBQUAD <>
BITMAPINFO ENDS

BITMAPCOREINFO STRUCT
  bmciHeader  BITMAPCOREHEADER <>
  bmciColors  RGBTRIPLE <>
BITMAPCOREINFO ENDS

BITMAPFILEHEADER STRUCT
  bfType        WORD      ?
  bfSize        DWORD      ?
  bfReserved1   WORD      ?
  bfReserved2   WORD      ?
  bfOffBits     DWORD      ?
BITMAPFILEHEADER ENDS



; ----------------------------------------------------------------------------
; Function definitions --- ANSI/UNICODE non-specific
; ============================================================================
externdef stdcall GetDC					:proto stdcall :dword
externdef stdcall ReleaseDC			:proto stdcall :dword, :dword

externdef stdcall CreateCompatibleBitmap	:proto stdcall :dword, :dword, :dword
externdef stdcall CreateCompatibleDC	:proto stdcall :dword
externdef stdcall DeleteDC					:proto stdcall :dword

externdef stdcall SelectObject			:proto stdcall :dword, :dword
externdef stdcall DeleteObject			:proto stdcall :dword

externdef stdcall BitBlt					:proto stdcall :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword 

externdef stdcall CreateRectRgn			:proto stdcall :dword, :dword, :dword, :dword
externdef stdcall CombineRgn				:proto stdcall :dword, :dword, :dword, :dword
externdef stdcall OffsetRgn				:proto stdcall :dword, :dword, :dword
externdef stdcall SelectClipRgn			:proto stdcall :dword, :dword 
externdef stdcall ExtCreateRegion		:proto stdcall :dword, :dword, :dword
	
externdef stdcall CreateDIBSection		:proto stdcall :dword, :dword, :dword, :dword, :dword, :dword
externdef stdcall CreateDIBitmap			:proto stdcall :dword, :dword, :dword, :dword, :dword, :dword
externdef stdcall SetBitmapBits			:proto stdcall :dword, :dword, :dword

externdef stdcall SetStretchBltMode		:proto stdcall :dword, :dword
externdef stdcall StretchBlt				:proto stdcall :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword
externdef stdcall StretchDIBits			:proto stdcall :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword, :dword


; ----------------------------------------------------------------------------
; Function definitions used in the WinOS Gdi32.DLL --- ANSI or UNICODE based
; on define during assembling
; ============================================================================
IF _UNICODE eq 1	; same definition as the MFC library (windows API uses UNICODE)
	include unicode\Gdi32.inc
ELSE
	include ansi\Gdi32.inc
ENDIF
