; ****************************************************************************
;   This file contains all defines (equates), structures and ANSI/UNICODE
;   function prototypes for the WinOS User32.DLL. ANSI or UNICODE specific
;   function prototypes are defined in their respective .INC file.
;
;   You may use or modify this code freely without any restrictions.
;
;   v1.0 - Initial coding of the file   Oct 10, 2006  4:00 PM
; ****************************************************************************

; ----------------------------------------------------------------------------
; WinOS User32.DLL library specific defines and global variables
; ============================================================================

; WM_MENUDRAG return values.
MND_CONTINUE	equ 0h
MND_ENDMENU		equ 1h

; MENUGETOBJECTINFO dwFlags values
MNGOF_TOPGAP		equ 1h
MNGOF_BOTTOMGAP	equ 2h

; WM_MENUGETOBJECT return values
MNGO_NOINTERFACE	equ 0h
MNGO_NOERROR		equ 1h

MIIM_STATE			equ 1h
MIIM_ID				equ 2h
MIIM_SUBMENU		equ 4h
MIIM_CHECKMARKS	equ 8h
MIIM_TYPE			equ 10h
MIIM_DATA			equ 20h
MIIM_STRING			equ 40h
MIIM_BITMAP			equ 80h
MIIM_FTYPE			equ 100h

HBMMENU_CALLBACK				equ ffffffffh
HBMMENU_SYSTEM					equ 1h
HBMMENU_MBAR_RESTORE			equ 2h
HBMMENU_MBAR_MINIMIZE		equ 3h
HBMMENU_MBAR_CLOSE			equ 5h
HBMMENU_MBAR_CLOSE_D			equ 6h
HBMMENU_MBAR_MINIMIZE_D		equ 7h
HBMMENU_POPUP_CLOSE			equ 8h
HBMMENU_POPUP_RESTORE		equ 9h
HBMMENU_POPUP_MAXIMIZE		equ ah
HBMMENU_POPUP_MINIMIZE		equ bh

; ----------------------------------------------------------------------------
; WNDCLASSEX style definitions
; ============================================================================
CS_VREDRAW					equ 1h
CS_HREDRAW					equ 2h
CS_KEYCVTWINDOW			equ 4h
CS_DBLCLKS					equ 8h
CS_OWNDC						equ 20h
CS_CLASSDC					equ 40h
CS_PARENTDC					equ 80h
CS_NOKEYCVT					equ 100h
CS_NOCLOSE					equ 200h
CS_SAVEBITS					equ 800h
CS_BYTEALIGNCLIENT		equ 1000h
CS_BYTEALIGNWINDOW		equ 2000h
CS_PUBLICCLASS				equ 4000h
CS_GLOBALCLASS				equ CS_PUBLICCLASS
CS_IME						equ 10000h
cS_DROPSHADOW				equ 20000h


; ----------------------------------------------------------------------------
; Menu flags
; ============================================================================
MF_INSERT	equ 0h
MF_CHANGE	equ 80h
MF_APPEND	equ 100h
MF_DELETE	equ 200h
MF_REMOVE	equ 1000h

MF_BYCOMMAND	equ 0h
MF_BYPOSITION	equ 400h
MF_SEPARATOR	equ 800h

MF_ENABLED	equ 0h
MF_GRAYED	equ 1h
MF_DISABLED	equ 2h

MF_UNCHECKED			equ 0h
MF_CHECKED				equ 8h
MF_USECHECKBITMAPS	equ 200h

MF_STRING		equ 0h
MF_BITMAP		equ 4h
MF_OWNERDRAW	equ 100h

MF_POPUP				equ 10h
MF_MENUBARBREAK	equ 20h
MF_MENUBREAK		equ 40h

MF_UNHILITE	equ 0h
MF_HILITE	equ 80h

MF_DEFAULT			equ 1000h
MF_SYSMENU			equ 2000h
MF_HELP				equ 4000h
MF_RIGHTJUSTIFY	equ 4000h

MF_MOUSESELECT		equ 8000h
MF_END				equ 80h  		; Obsolete -- only used by old RES files

MFT_STRING			equ MF_STRING
MFT_BITMAP			equ MF_BITMAP
MFT_MENUBARBREAK	equ MF_MENUBARBREAK
MFT_MENUBREAK		equ MF_MENUBREAK
MFT_OWNERDRAW		equ MF_OWNERDRAW
MFT_RADIOCHECK		equ 200h
MFT_SEPARATOR		equ MF_SEPARATOR
MFT_RIGHTORDER		equ 2000h
MFT_RIGHTJUSTIFY	equ MF_RIGHTJUSTIFY

MFS_GRAYED		equ 3h
MFS_DISABLED	equ MFS_GRAYED
MFS_CHECKED		equ MF_CHECKED
MFS_HILITE		equ MF_HILITE
MFS_ENABLED		equ MF_ENABLED
MFS_UNCHECKED	equ MF_UNCHECKED
MFS_UNHILITE	equ MF_UNHILITE
MFS_DEFAULT		equ MF_DEFAULT


; ----------------------------------------------------------------------------
; GetSystemMetrics() codes		(values in decimal)
; ============================================================================
SM_CXSCREEN             equ 0
SM_CYSCREEN             equ 1
SM_CXVSCROLL            equ 2
SM_CYHSCROLL            equ 3
SM_CYCAPTION            equ 4
SM_CXBORDER             equ 5
SM_CYBORDER             equ 6
SM_CXDLGFRAME           equ 7
SM_CYDLGFRAME           equ 8
SM_CYVTHUMB             equ 9
SM_CXHTHUMB             equ 10
SM_CXICON               equ 11
SM_CYICON               equ 12
SM_CXCURSOR             equ 13
SM_CYCURSOR             equ 14
SM_CYMENU               equ 15
SM_CXFULLSCREEN         equ 16
SM_CYFULLSCREEN         equ 17
SM_CYKANJIWINDOW        equ 18
SM_MOUSEPRESENT         equ 19
SM_CYVSCROLL            equ 20
SM_CXHSCROLL            equ 21
SM_DEBUG                equ 22
SM_SWAPBUTTON           equ 23
SM_CXMIN                equ 28
SM_CYMIN                equ 29
SM_CXSIZE               equ 30
SM_CYSIZE               equ 31
SM_CXFRAME              equ 32
SM_CYFRAME              equ 33
SM_CXMINTRACK           equ 34
SM_CYMINTRACK           equ 35
SM_CXDOUBLECLK          equ 36
SM_CYDOUBLECLK          equ 37
SM_CXICONSPACING        equ 38
SM_CYICONSPACING        equ 39
SM_MENUDROPALIGNMENT    equ 40
SM_PENWINDOWS           equ 41
SM_DBCSENABLED          equ 42
SM_CMOUSEBUTTONS        equ 43

SM_CXFIXEDFRAME         equ SM_CXDLGFRAME  ; win40 name change
SM_CYFIXEDFRAME         equ SM_CYDLGFRAME  ; win40 name change
SM_CXSIZEFRAME          equ SM_CXFRAME     ; win40 name change
SM_CYSIZEFRAME          equ SM_CYFRAME     ; win40 name change

SM_SECURE               equ 44
SM_CXEDGE               equ 45
SM_CYEDGE               equ 46
SM_CXMINSPACING         equ 47
SM_CYMINSPACING         equ 48
SM_CXSMICON             equ 49
SM_CYSMICON             equ 50
SM_CYSMCAPTION          equ 51
SM_CXSMSIZE             equ 52
SM_CYSMSIZE             equ 53
SM_CXMENUSIZE           equ 54
SM_CYMENUSIZE           equ 55
SM_ARRANGE              equ 56
SM_CXMINIMIZED          equ 57
SM_CYMINIMIZED          equ 58
SM_CXMAXTRACK           equ 59
SM_CYMAXTRACK           equ 60
SM_CXMAXIMIZED          equ 61
SM_CYMAXIMIZED          equ 62
SM_NETWORK              equ 63
SM_CLEANBOOT            equ 67
SM_CXDRAG               equ 68
SM_CYDRAG               equ 69
SM_SHOWSOUNDS           equ 70
SM_CXMENUCHECK          equ 71   ; Use instead of GetMenuCheckMarkDimensions
SM_CYMENUCHECK          equ 72
SM_SLOWMACHINE          equ 73
SM_MIDEASTENABLED       equ 74
SM_MOUSEWHEELPRESENT    equ 75
SM_XVIRTUALSCREEN       equ 76
SM_YVIRTUALSCREEN       equ 77
SM_CXVIRTUALSCREEN      equ 78
SM_CYVIRTUALSCREEN      equ 79
SM_CMONITORS            equ 80
SM_SAMEDISPLAYFORMAT    equ 81
SM_IMMENABLED           equ 82
SM_CXFOCUSBORDER        equ 83
SM_CYFOCUSBORDER        equ 84
SM_TABLETPC             equ 86
SM_MEDIACENTER          equ 87
SM_CMETRICS             equ 88

SM_REMOTESESSION        equ 1000h
SM_SHUTTINGDOWN         equ 2000h
SM_REMOTECONTROL        equ 2001h


; Owner draw control types
ODT_MENU        equ 1h
ODT_LISTBOX     equ 2h
ODT_COMBOBOX    equ 3h
ODT_BUTTON      equ 4h
ODT_STATIC      equ 5h

; Owner draw actions
ODA_DRAWENTIRE  equ 1h
ODA_SELECT      equ 2h
ODA_FOCUS       equ 4h

; Owner draw state
ODS_SELECTED		equ 1h
ODS_GRAYED			equ 2h
ODS_DISABLED		equ 4h
ODS_CHECKED			equ 8h
ODS_FOCUS			equ 10h
ODS_DEFAULT			equ 20h
ODS_HOTLIGHT		equ 40h
ODS_INACTIVE		equ 80h
ODS_NOACCEL			equ 100h
ODS_NOFOCUSRECT	equ 200h
ODS_COMBOBOXEDIT	equ 1000h


; flags for DrawFrameControl
DFC_CAPTION     equ 1h
DFC_MENU        equ 2h
DFC_SCROLL      equ 3h
DFC_BUTTON      equ 4h
DFC_POPUPMENU   equ 5h

DFCS_CAPTIONCLOSE   equ 0h
DFCS_CAPTIONMIN     equ 1h
DFCS_CAPTIONMAX     equ 2h
DFCS_CAPTIONRESTORE equ 3h
DFCS_CAPTIONHELP    equ 4h

DFCS_MENUARROW      equ 0h
DFCS_MENUCHECK      equ 1h
DFCS_MENUBULLET     equ 2h
DFCS_MENUARROWRIGHT equ 4h

DFCS_SCROLLUP               equ 0h
DFCS_SCROLLDOWN             equ 1h
DFCS_SCROLLLEFT             equ 2h
DFCS_SCROLLRIGHT            equ 3h
DFCS_SCROLLCOMBOBOX         equ 5h
DFCS_SCROLLSIZEGRIP         equ 8h
DFCS_SCROLLSIZEGRIPRIGHT    equ 10h

DFCS_BUTTONCHECK        equ 0h
DFCS_BUTTONRADIOIMAGE   equ 1h
DFCS_BUTTONRADIOMASK    equ 2h
DFCS_BUTTONRADIO        equ 4h
DFCS_BUTTON3STATE       equ 8h
DFCS_BUTTONPUSH         equ 10h

DFCS_INACTIVE   equ 100h
DFCS_PUSHED     equ 200h
DFCS_CHECKED    equ 400h

DFCS_TRANSPARENT    equ 800h
DFCS_HOT            equ 1000h

DFCS_ADJUSTRECT equ 2000h
DFCS_FLAT       equ 4000h
DFCS_MONO       equ 8000h


; WNDCLASSEX structure definition
WNDCLASSEX STRUCT
  cbSize            DWORD ?		; must be set to the size of WNDCLASSEX
  style             DWORD ?		; class styles to use.
  lpfnWndProc       DWORD ?		; window procedure called to process messages
  cbClsExtra        DWORD ?		; extra data for this class
  cbWndExtra        DWORD ?		; extra data for each window creating on this class
  hInstance         DWORD ?		; process or dll instance where class is instaniated
  hIcon             DWORD ?		; default icon to use for windows
  hCursor           DWORD ?		; default cursor to use for windows
  hbrBackground     DWORD ?		; default color to set the background
  lpszMenuName      DWORD ?		; default menu associated with window
  lpszClassName     DWORD ?		; name of the class (custom or OS specific)
  hIconSm           DWORD ?		; small icon to display in the window
WNDCLASSEX ENDS

; MDINEXTMENU structure definition
MDINEXTMENU STRUCT
    hmenuIn     dword ?	; HMENU
    menuNext    dword ?	; HMENU
    hwndNext    dword ?	; HWND
MDINEXTMENU ENDS

; ----------------------------------------------------------------------------
; MENUBARINFO structure definition
; ============================================================================
MENUBARINFO STRUCT
    cbSize      dword ?
    rcBar       RECTL<>	; rect of bar, popup, item
    hMenu       dword ?	; real menu handle of bar, popup		(HMENU)
    hwndMenu    dword ?	; hwnd of item submenu if one			(HWND)
    fBarFocused dword ?	; bar, popup has the focus				(BOOL:1)
    fFocused    dword ?	; item has the focus						(BOOL:1)
MENUBARINFO ENDS

; ----------------------------------------------------------------------------
; MENUEX_TEMPLATE_HEADER and MENUEX_TEMPLATE_ITEM structure definitions
; ============================================================================
MENUEX_TEMPLATE_HEADER STRUCT
    wVersion    word ?
    wOffset     word ?
    dwHelpId    dword ?
MENUEX_TEMPLATE_HEADER ENDS

MENUEX_TEMPLATE_ITEM STRUCT
    dwHelpId    dword ?
    dwType      dword ?
    dwState     dword ?
    menuId      dword ?
    bResInfo    word ?
    szText      dword ?		; UNICODE POINTER
MENUEX_TEMPLATE_ITEM ENDS

; MENUINFO structure definition
MENUINFO STRUCT
    cbSize          dword ?
    fMask           dword ?
    dwStyle         dword ?
    cyMax           dword ?
    hbrBack         dword ?	; HBRUSH
    dwContextHelpID dword ?
    dwMenuData      dword ?	; ULONG_PTR
MENUINFO ENDS 

; ----------------------------------------------------------------------------
; MENUITEMINFO structure definition
;		NOTE:
;			dwTypeData define is a pointer to a ANSI or UNICODE string. 
; ============================================================================
MENUITEMINFO STRUCT
	cbSize		dword ?
	fMask			dword ?
	fType			dword ?
	fState		dword ?
	wID			dword ?
	hSubMenu		dword ?		; HMENU
	hbmpChecked	dword ?		; HBITMAP
	hbmpUnchecked dword ?	; HBITMAP
	dwItemData	dword ?		; ULONG_PTR
	dwTypeData	dword ?		; ANSI or UNICODE data
	cch			dword ?
	hbmpItem		dword ?		; HBITMAP 
MENUITEMINFO ENDS

; ----------------------------------------------------------------------------
; MENUGETOBJECTINFO structure definition
; ============================================================================
MENUGETOBJECTINFO STRUCT
	dwFlags		dword ?
	uPos			dword ?
	hmenu			dword ?
	riid			dword ?
	pvObj			dword ?
MENUGETOBJECTINFO ENDS

; ----------------------------------------------------------------------------
; TPMPARAMS structure definition
; ============================================================================
TPMPARAMS STRUCT
	cbSize		dword ?
	rcExclude 	RECTL<>
TPMPARAMS ENDS

; MEASUREITEMSTRUCT for ownerdraw
MEASUREITEMSTRUCT STRUCT
    CtlType     dword ?
    CtlID       dword ?
    itemID      dword ?
    itemWidth   dword ?
    itemHeight  dword ?
    itemData    dword ?
MEASUREITEMSTRUCT ENDS

; DRAWITEMSTRUCT for ownerdraw
DRAWITEMSTRUCT STRUCT
    CtlType     dword ?
    CtlID       dword ?
    itemID      dword ?
    itemAction  dword ?
    itemState   dword ?
    hwndItem    dword ?	; HWND
    hDC         dword ?	; HDC
    rcItem      RECTL<>
    itemData    dword ?	; ULONG_PTR
DRAWITEMSTRUCT ENDS

; DELETEITEMSTRUCT for ownerdraw
DELETEITEMSTRUCT STRUCT
    CtlType     dword ?
    CtlID       dword ?
    itemID      dword ?
    hwndItem    dword ?	; HWND
    itemData    dword ?	; ULONG_PTR
DELETEITEMSTRUCT ENDS

; COMPAREITEMSTUCT for ownerdraw sorting
COMPAREITEMSTRUCT STRUCT
	CtlType		dword ?
	CtlID			dword ?
	hwndItem		dword ?	; HWND
	itemID1		dword ?
	itemData1	dword ?	; ULONG_PTR
	itemID2		dword ?
	itemData2	dword ?	; ULONG_PTR
	dwLocaleId	dword ?
COMPAREITEMSTRUCT ENDS


; ----------------------------------------------------------------------------
; Function definitions --- ANSI/UNICODE non-specific
; ============================================================================
externdef stdcall DestroyAcceleratorTable		:proto stdcall :dword
externdef stdcall TranslateMessage				:proto stdcall :dword

externdef stdcall GetSystemMetrics				:proto stdcall :dword
externdef stdcall DrawFrameControl              :proto stdcall :dword, :dword, :dword, :dword

; menu prototypes
externdef stdcall CheckMenuItem					:proto stdcall :dword, :dword, :dword
externdef stdcall CheckMenuRadioItem			:proto stdcall :dword, :dword, :dword, :dword
externdef stdcall CreateMenu						:proto stdcall
externdef stdcall CreatePopupMenu				:proto stdcall
externdef stdcall DeleteMenu						:proto stdcall :dword, :dword, :dword
externdef stdcall DestroyMenu						:proto stdcall :dword
externdef stdcall DrawMenuBar						:proto stdcall :dword
externdef stdcall EnableMenuItem					:proto stdcall :dword, :dword, :dword
externdef stdcall EndMenu							:proto stdcall
externdef stdcall GetMenu							:proto stdcall :dword
externdef stdcall GetMenuBarInfo					:proto stdcall :dword, :dword, :dword, :dword
externdef stdcall GetMenuDefaultItem			:proto stdcall :dword, :dword, :dword
externdef stdcall GetMenuInfo						:proto stdcall :dword, :dword
externdef stdcall GetMenuItemCount				:proto stdcall :dword
externdef stdcall GetMenuItemID					:proto stdcall :dword, :dword
externdef stdcall GetMenuItemRect				:proto stdcall :dword, :dword, :dword, :dword
externdef stdcall GetMenuState					:proto stdcall :dword, :dword, :dword 
externdef stdcall GetSubMenu						:proto stdcall :dword, :dword
externdef stdcall GetSystemMenu					:proto stdcall :dword, :dword
externdef stdcall HiliteMenuItem					:proto stdcall :dword, :dword, :dword, :dword
externdef stdcall IsMenu							:proto stdcall :dword
externdef stdcall MenuItemFromPoint				:proto stdcall :dword, :dword, :dword, :dword ; :POINTL<>
externdef stdcall RemoveMenu						:proto stdcall :dword, :dword, :dword
externdef stdcall SetMenu							:proto stdcall :dword, :dword
externdef stdcall SetMenuDefaultItem			:proto stdcall :dword, :dword, :dword
externdef stdcall SetMenuItemBitmaps			:proto stdcall :dword, :dword, :dword, :dword, :dword
externdef stdcall TrackPopupMenu					:proto stdcall :dword, :dword, :dword, :dword, :dword, :dword, :dword
externdef stdcall TrackPopupMenuEx				:proto stdcall :dword, :dword, :dword, :dword, :dword, :dword


; ----------------------------------------------------------------------------
; Function definitions used in the WinOS User32.DLL --- ANSI or UNICODE based
; on define during assembling
; ============================================================================
IF _UNICODE eq 1	; same definition as the MFC library (windows API uses UNICODE)
	include unicode\User32.inc
ELSE
	include ansi\User32.inc
ENDIF
