// ---------------------------------------------------------------------------
// Analysis.h
// ===========================================================================
#ifndef __ASM_ANALYSIS_H__
#define __ASM_ANALYSIS_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#ifdef __cplusplus
extern "C" {
#endif

// ---------------------------------------------------------------------------
// Prototypes for user-defined compare routines (both __cdelc and __stdcall
// calling conventions).
// ---------------------------------------------------------------------------
typedef int (__cdecl   *pfnCOMPARE)(const void* pElem1, const void* pElem2);
typedef int (__stdcall *pfnCompare)(const void* pElem1, const void* pElem2);
typedef enum { VSCRYPT_ENCRYPT = 1, VSCRYPT_DECRYPT = 2 } eVSCryptType;



// ANSI and UNICODE ASM prototypes
    LPVOID  __stdcall BinarySearch(IN LPCVOID pTarget, IN LPCVOID pArray, IN const DWORD dwArrayCount, IN const DWORD dwElemSize, IN pfnCOMPARE compare);
    DWORD   __stdcall Crc32(IN const DWORD crc, IN LPCVOID pBuffer, IN const DWORD BufLen);
    DWORD   __stdcall Hash32(IN LPCVOID Buffer, IN const DWORD BufLen);
    DWORD   __stdcall Hash32NoCase(IN LPCVOID Buffer, IN const DWORD BufLen);
    LPVOID  __stdcall LinearSearch(IN LPCVOID pTarget, IN LPCVOID pArray, IN const DWORD dwArrayCount, IN const DWORD dwElemSize, IN pfnCOMPARE compare);
    LPVOID  __stdcall LinearSearchNum(IN LPCVOID pTarget, IN LPCVOID pArray, IN const DWORD dwArrayCount, IN const DWORD dwElemSize, IN const DWORD dwOffset);
    void    __stdcall QuickSort(IN void** Array, IN const DWORD Count, int (__stdcall *comp)(const void *, const void *));


// UNICODE ASM prototypes
    LPVOID  __stdcall LinearSearchStrW(IN LPCVOID pTarget, IN LPCVOID pArray, IN const DWORD dwArrayCount, IN const DWORD dwElemSize, IN const DWORD dwOffset);
    void    __stdcall VSCryptW(IN const int nMode, IN const wchar_t* pwszInString, OUT wchar_t* pwszOutString);


// ANSI ASM prototypes
    LPVOID  __stdcall LinearSearchStrA(IN LPCVOID pTarget, IN LPCVOID pArray, IN const DWORD dwArrayCount, IN const DWORD dwElemSize, IN const DWORD dwOffset);
    void    __stdcall VSCryptA(IN const int nMode, IN const char* pszInString, OUT char* pszOutString);


// Generic defines to allow a single name to cover both types
#if defined(_UNICODE)
    #define LinearSearchStr     LinearSearchStrW
    #define VSCrypt             VSCryptW
#else
    #define LinearSearchStr     LinearSearchStrA
    #define VSCrypt             VSCryptA
#endif


#ifdef __cplusplus
}
#endif

// ===========================================================================
#endif // #define __ASM_ANALYSIS_H__
