; ****************************************************************************
;   This file contains all defines (equates), structures and ANSI/UNICODE
;   function prototypes for the 'Analysis' library. ANSI or UNICODE specific
;   function prototypes are defined in their respective .INC file.
;
;   You may use or modify this code freely without any restrictions.
;
;   v1.0 - Initial coding of the file   Oct 10, 2006  4:00 PM
; ****************************************************************************

; ----------------------------------------------------------------------------
; Analysis library specific defines and global variables
; ============================================================================
VSCRYPT_ENCRYPT     equ 1h
VSCRYPT_DECRYPT     equ 2h


; ----------------------------------------------------------------------------
; Functions from other "asm" libraries
; ============================================================================


; ----------------------------------------------------------------------------
; Function definitions --- ANSI/UNICODE non-specific
; ============================================================================
externdef stdcall BinarySearch      :proto stdcall :dword, :dword, :dword, :dword, :dword
externdef stdcall QuickSort         :proto stdcall :dword, :dword, :dword
externdef stdcall Crc32             :proto stdcall :dword, :dword, :dword
externdef stdcall Hash32            :proto stdcall :dword, :dword
externdef stdcall Hash32NoCase      :proto stdcall :dword, :dword
externdef stdcall LinearSearch      :proto stdcall :dword, :dword, :dword, :dword, :dword
externdef stdcall LinearSearchNum   :proto stdcall :dword, :dword, :dword, :dword, :dword


; ----------------------------------------------------------------------------
; Function definitions --- ANSI or UNICODE based on define during assembling
; ============================================================================
IF _UNICODE eq 1	; same definition as the MFC library (windows API uses UNICODE)
	include unicode\asm_Analysis.inc
ELSE
	include ansi\asm_Analysis.inc
ENDIF
