// ---------------------------------------------------------------------------
// io.h
// ===========================================================================
#ifndef __ASM_FILEIO_H__
#define __ASM_FILEIO_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef __cplusplus
extern "C" {
#endif


// UNICODE ASM prototypes
   HANDLE __stdcall fileCreateW(const wchar_t* FileSpec, const DWORD dwCreateDisposition);
   HANDLE __stdcall fileOpenW(const wchar_t* FileSpec, const DWORD dwDesiredAccess);


// ANSI ASM prototypes
   HANDLE __stdcall fileCreateA(const char* FileSpec, const DWORD dwCreateDisposition);
   HANDLE __stdcall fileOpenA(const char* FileSpec, const DWORD dwDesiredAccess);


// Generic ASM prototypes
   void __stdcall fileClose(HANDLE* hFile);
   BOOL __stdcall fileWrite(HANDLE hFile, const void* Buffer, size_t BufSize);
   BOOL __stdcall fileRead(HANDLE hFile, void* Buffer, size_t BufSize);


// Generic defines to allow a single name to cover both types
#if defined(_UNICODE)
	#define fileCreate  fileCreateW
	#define fileOpen    fileOpenW
#else
	#define fileCreate  fileCreateA
	#define fileOpen    fileOpenA
#endif


#ifdef __cplusplus
}
#endif

// ===========================================================================
#endif // #define __ASM_FILEIO_H__

