; ****************************************************************************
;   This file contains all defines (equates), structures and ANSI/UNICODE
;   function prototypes for the 'Memory' library. ANSI or UNICODE specific
;   function prototypes are defined in their respective .INC file.
;
;   You may use or modify this code freely without any restrictions.
;
;   v1.0 - Initial coding of the file   Oct 10, 2006  4:00 PM
; ****************************************************************************

; ----------------------------------------------------------------------------
; Memory library specific defines and global variables
; ============================================================================
externdef hProcessHeap:dword    ; defined in MemInit.asm


; ----------------------------------------------------------------------------
; Functions from other "asm" libraries
; ============================================================================


; ----------------------------------------------------------------------------
; Function definitions --- ANSI/UNICODE non-specific
; ============================================================================
externdef stdcall fmInitialize  :proto stdcall
externdef stdcall fmClear       :proto stdcall :dword, :dword
externdef stdcall fmCopy        :proto stdcall :dword, :dword, :dword
externdef stdcall fmAlloc       :proto stdcall :dword
externdef stdcall fmFree        :proto stdcall :dword
externdef stdcall fmResize      :proto stdcall :dword, :dword


; ----------------------------------------------------------------------------
; Function definitions --- ANSI or UNICODE based on define during assembling
; ============================================================================
IF _UNICODE eq 1	; same definition as the MFC library (windows API uses UNICODE)
	include unicode\asm_Memory.inc
ELSE
	include ansi\asm_Memory.inc
ENDIF
