// ---------------------------------------------------------------------------
// asm_strings.h
// ===========================================================================
#ifndef __ASM_Strings_H__
#define __ASM_Strings_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef __cplusplus
extern "C" {
#endif

typedef enum { StringCaseLower, StringCaseUpper } enumStringCaseType;

// ANSI and UNICODE ASM prototypes


// UNICODE ASM prototypes
    ULONG       __stdcall HexToULongW(const wchar_t* pHexString);
    void        __stdcall LeftTrimWhiteSpaceW(wchar_t* pString);
    wchar_t*    __stdcall strCaseW(wchar_t* pString, const enumStringCaseType eType);
    void        __stdcall strCatW(wchar_t* pDestString, const wchar_t* pSrcString);
    wchar_t*    __stdcall strCharW(const wchar_t* pString, const wchar_t chr);
    int         __stdcall strCompareW(const wchar_t* pString1, const wchar_t* pString2);
    void        __stdcall strCopyW(wchar_t* pDestString, const wchar_t* pSrcString);
    wchar_t*    __stdcall strDupW(const wchar_t* pSrcString);
    int         __stdcall strLengthW(const wchar_t* pString);
    wchar_t*    __stdcall strLowerW(wchar_t* pString);
    void        __stdcall strRemoveW(wchar_t* pDestString, const wchar_t* pSrcString, const wchar_t* pSubChars);
    wchar_t*    __stdcall strSubW(const wchar_t* pSrcString, const wchar_t* pSubString);
    wchar_t*    __stdcall strUpperW(wchar_t* pString);
    void        __stdcall RightTrimWhiteSpaceW(wchar_t* pString);
    void        __stdcall TrimWhiteSpaceW(wchar_t* pString);
    void        __cdecl   vsprintfW(wchar_t* Buf, const wchar_t* fmt, ...);

// ANSI ASM prototypes
    ULONG   __stdcall HexToULongA(const char* pHexString);
    void    __stdcall LeftTrimWhiteSpaceA(char* pString);
    char*   __stdcall strCaseA(char* pString, const enumStringCaseType eType);
    void    __stdcall strCatA(char* pDestString, const char* pSrcString);
    char*   __stdcall strCharA(const char* pString, const char chr);
    int     __stdcall strCompareA(const char* pString1, const char* pString2);
    void    __stdcall strCopyA(char* pDestString, const char* pSrcString);
    char*   __stdcall strDupA(const char* pSrcString);
    int     __stdcall strLengthA(const char* pString);
    char*   __stdcall strLowerA(wchar_t* pString);
    void    __stdcall strRemoveA(char* pDestString, const char* pSrcString, const char* pSubChars);
    char*   __stdcall strSubA(const char* pSrcString, const char* pSubString);
    char*   __stdcall strUpperA(char* pString);
    void    __stdcall RightTrimWhiteSpaceA(char* pString);
    void    __stdcall TrimWhiteSpaceA(char* pString);
    void    __cdecl   vsprintfA(char* Buf, const char* fmt, ...);


// Generic defines to allow a single name to cover both types
#if defined(_UNICODE)
    #define HexToULong  HexToULongW
    #define strCase     strCaseW
    #define strCat      strCatW
    #define strChar     strCharW
    #define strCompare  strCompareW
    #define strCopy     strCopyW
    #define strDup      strDupW
    #define strLength   strLengthW
    #define strLower    strLowerW
    #define strRemove   strRemoveW
    #define strSub      strSubW
    #define strUpper    strUpperW
    #define vsprintf    vsprintfW
    #define LeftTrimWhiteSpace      LeftTrimWhiteSpaceW
    #define RightTrimWhiteSpace     RightTrimWhiteSpaceW
    #define TrimWhiteSpace          TrimWhiteSpaceW
#else
    #define HexToULong  HexToULongA
    #define strCase     strCaseA
    #define strCat      strCatA
    #define strChar     strCharA
    #define strCompare  strCompareA
    #define strCopy     strCopyA
    #define strDup      strDupA
    #define strLength   strLengthA
    #define strLower    strLowerA
    #define strRemove   strRemoveA
    #define strSub      strSubA
    #define strUpper    strUpperA
    #define vsprintf    vsprintfA
    #define LeftTrimWhiteSpace      LeftTrimWhiteSpaceA
    #define RightTrimWhiteSpace     RightTrimWhiteSpaceA
    #define TrimWhiteSpace          TrimWhiteSpaceA
#endif


#ifdef __cplusplus
}
#endif

// ===========================================================================
#endif // #define __ASM_Strings_H__
