// ---------------------------------------------------------------------------
// Arrays.h
// ===========================================================================
#ifndef __ASM_FASTARRAY_H__
#define __ASM_FASTARRAY_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct ArrayObject
{
    LPVOID* Array;
    LONG    Size;
    LONG    Count;
};

#define AO_SUCCESS				(0)	// success
#define AO_PARAMS_INVALID		(-1)	// invalid params passed into function
#define AO_OUT_OF_MEMORY		(-2)	// out of memory error
#define AO_CREATE_FIRST			(-3)	// must call faCreate() first
#define AO_INDEX_OUT_OF_RANGE	(-4)	// index parameter out of bounds
#define AO_NOTFOUND				(-5)	// element pointer not found


#ifdef __cplusplus
extern "C" {
#endif

// ---------------------------------------------------------------------------
// Prototypes for user-defined compare routines (both __cdelc and __stdcall
// calling conventions).
// ---------------------------------------------------------------------------
typedef int (__cdecl   *pfnCOMPARE)(const void* pElem1, const void* pElem2);
typedef int (__stdcall *pfnCompare)(const void* pElem1, const void* pElem2);


// Generic ASM prototypes
    LONG    __stdcall faCreate(ArrayObject* pObject);
    void    __stdcall faDestroy(ArrayObject* pObject);
    LONG    __stdcall faCheckParameters(const ArrayObject* pObject, const LONG index, BOOL checkidx);
    LONG    __stdcall faAddElement(ArrayObject* pObject, LPVOID pElement);
    LPVOID  __stdcall faGetElementByIndex(const ArrayObject* Object, const LONG Index);
    LONG    __stdcall faGetIndexByElement(const ArrayObject* Object, LPCVOID pElement);
    LONG    __stdcall faRemoveElementByIndex(ArrayObject* Object, const LONG Index);
    LONG    __stdcall faRemoveElementByPointer(ArrayObject* Object, LPCVOID pElement);
    LONG    __stdcall faSortElements(ArrayObject* pObject, int (__stdcall *comp)(const void *, const void *));

// UNICODE ASM prototypes


// ANSI ASM prototypes


// Generic defines to allow a single name to cover both types
#if defined(_UNICODE)
#else
#endif



#ifdef __cplusplus
}
#endif

// ===========================================================================
#endif // #define __ASM_FASTARRAY_H__
