; ****************************************************************************
;   This file contains all defines (equates), structures and ANSI/UNICODE
;   function prototypes for the 'Strings' library. ANSI or UNICODE specific
;   function prototypes are defined in their respective .INC file.
;
;   You may use or modify this code freely without any restrictions.
;
;   v1.0 - Initial coding of the file   Oct 10, 2006  4:00 PM
; ****************************************************************************

; ----------------------------------------------------------------------------
; Strings library specific defines and global variables
; ============================================================================
AO_SUCCESS              equ 0h          ; success
AO_PARAMS_INVALID       equ 0ffffffffh  ; invalid params passed into function
AO_OUT_OF_MEMORY        equ 0fffffffeh  ; lout of memory error
AO_CREATE_FIRST         equ 0fffffffdh  ;
AO_INDEX_OUT_OF_RANGE   equ 0fffffffch  ;
AO_NOTFOUND             equ 0fffffffbh  ;
AO_ALLOC_SIZE           equ 0100h       ; number of allocated elem spots in array


ArrayObject STRUCT
	Array       dword ? ; ptr to array
	AllocSize   dword ? ; max num of allocated elememts in array
	Count       dword ? ; current num of elements in array
ArrayObject ENDS


; ----------------------------------------------------------------------------
; Function definitions --- ANSI/UNICODE non-specific
; ============================================================================
externdef stdcall faCreate      :proto stdcall :dword
externdef stdcall faDestroy     :proto stdcall :dword

externdef stdcall faCheckParameters     :proto stdcall :dword, :dword, :dword
externdef stdcall faSortElements        :proto stdcall :dword, :dword

externdef stdcall faAddElement              :proto stdcall :dword, :dword
externdef stdcall faGetIndexByElement       :proto stdcall :dword, :dword
externdef stdcall faGetElementByIndex       :proto stdcall :dword, :dword
externdef stdcall faRemoveElementByIndex    :proto stdcall :dword, :dword
externdef stdcall faRemoveElementByPointer  :proto stdcall :dword, :dword


; ----------------------------------------------------------------------------
; Function definitions --- ANSI or UNICODE based on define during assembling
; ============================================================================
IF _UNICODE eq 1	; same definition as the MFC library (windows API uses UNICODE)
	include unicode\asm_faArray.inc
ELSE
	include ansi\asm_faArray.inc
ENDIF
