; ****************************************************************************
; NOTE:
;   These macros all use the fs segment register which may not be compatible
;   with operating systems other then Windows 2000 and Windows XP and future
;   version of these operating systems may change that.
;
;   The best way to use these macros is 'not' to use them and instead, call
;   the Win32 API that is equivalent to them. ;-)
;
;   Since that above disclaimer is made, feel free to use these macros in any
;   code you see fit to use. Use at your own risk.
;
;   v1.0 - Initial coding of the file   Dec 30, 2004  1:00 PM
;      - mSetLastError macro added
;      - mGetLastError macro added
; ****************************************************************************


; ----------------------------------------------------------------------------
; NAME:
;	 mSetLastError
;
; DESCRIPTION:
;   This will set the internal windows error number to the specified value.
;   You can use this macro to replace the Win32 API call:
;      SetLastError(x);
;
; USAGE:
;    mSetLastError ecx	; any register other then eax
;    mSetLastError [ecx] 
;    mSetLastError 133	; any value
;
; Registers used:
;   sets fs:nothing
;	 EAX
; ============================================================================
mSetLastError MACRO ErrNum
   assume fs:nothing
   mov eax, dword ptr fs:[18h]
   mov dword ptr [eax+34h], ErrNum
ENDM


; ----------------------------------------------------------------------------
; NAME:
;	 mGetLastError
;
; DESCRIPTION:
;   This will get the internal windows error number and place it in the EAX
;   register. You can use this macro to replace the Win32 API call:
;      x = GetLastError();
;
; USAGE:
;    mGetLastError
;
; Registers used:
;   sets fs:nothing
;	 EAX
; ============================================================================
mGetLastError MACRO
   assume fs:nothing
   mov eax, dword ptr fs:[18h]
   mov eax, dword ptr [eax+34h]
   EXIT<eax>
ENDM

