TITLE "Creates a new file."

.586
.model flat				; memory model
option casemap:none	; case sensitive

include kernel32.inc

.code

align 16
; ----------------------------------------------------------------------------
; prototype:
;   HANDLE __stdcall fileCreateA(const char* FileSpec, const DWORD dwCreateDisposition);
;
; description:
;		This function creates a file, directory, physical disk, volume,
;		console buffer, tape drive, communications resource, mailslot, or pipe
;		and then can be used for both reading and writing.
;
; returns:
;		If the function succeeds, the return value is an open handle to the
;		specified file.
;		
;		If the function fails, the return value is INVALID_HANDLE_VALUE.
;		To get extended error information, call GetLastError.
;
;
; ESP + 4 = FileSpec parameter
; ESP + 8 = Create Type
; ============================================================================
_fileCreateA@8 PROC NEAR

	; set up registers for our CreateFile() api call.
	mov edx, [esp + 8]
	mov ecx, [esp + 4]
	xor eax, eax
	
	; push parameters for Win32 API call
	push eax									; hTemplateFile
	push FILE_ATTRIBUTE_NORMAL					; dwFlagsAndAttributes
	push edx									; dwCreationDisposition
	push eax									; lpSecurityAttributes
	push FILE_SHARE_READ or FILE_SHARE_WRITE	; dwShareMode
	push GENERIC_READ or GENERIC_WRITE			; dwDesiredAccess
	push ecx									; lpFileName
	call CreateFileA
	
	ret 8	
_fileCreateA@8 ENDP

END
