TITLE "Opens an existing file."

.586
.model flat				; memory model
option casemap:none	; case sensitive

include kernel32.inc

.code

align 16
; ----------------------------------------------------------------------------
; prototype:
;   HANDLE __stdcall fileOpenW(const wchar_t* FileSpec, const DWORD dwDesiredAccess);
;
; description:
;		This function opens a file, directory, physical disk, volume,
;		console buffer, tape drive, communications resource, mailslot, or pipe
;		for reading, writing or both.
;
; returns:
;		If the function succeeds, the return value is an open handle to the
;		specified file.
;		
;		If the function fails, the return value is INVALID_HANDLE_VALUE.
;		To get extended error information, call GetLastError.
;
;
; ESP + 4 = FileSpec parameter
; ESP + 8 = Desired Access mode	(read, write or both)
; ============================================================================
_fileOpenW@8 PROC NEAR

	; set up registers for our CreateFile() api call.
	mov edx, [esp + 8]
	mov ecx, [esp + 4]
	xor eax, eax
	
	; push parameters for Win32 API call
	push eax												; hTemplateFile
	push FILE_ATTRIBUTE_NORMAL						; dwFlagsAndAttributes
	push OPEN_EXISTING 								; dwCreationDisposition
	push eax												; lpSecurityAttributes
	push FILE_SHARE_READ or FILE_SHARE_WRITE 	; dwShareMode
	push edx												; dwDesiredAccess
	push ecx												; lpFileName
	call CreateFileW
	
	ret 8
_fileOpenW@8 ENDP

END
