TITLE	"Fast Memory Routines -- Clear(zero)"

.586
.model flat      				; memory model & calling convention
option casemap :none     	; case sensitive
option readonly

.code

align 16
; ----------------------------------------------------------------------------
; Prototype:
;   void __stdcall fmClear(LPVOID pAddr, size_t dwSize);
;
; Description:
;   Set all the bytes in the memory block to zero.
;
; Returns:
;   (none)
; ----------------------------------------------------------------------------

; ---------------------------------------------------------------------------
; variable offests into ESP upon function entering and adjustment of the
; stack for local variables and register preservation
; ===========================================================================
; ESP + 8  = pAddr parameter
; ESP + 12 = dwSize parameter
; ===========================================================================
_fmClear@8 proc near
	; save the EDI
	push edi
	
	; set up register for zeroing
	mov edi, [esp + 8]
	mov ecx, [esp + 12]
	mov edx, [esp + 12]
	xor eax, eax
	shr ecx, 2
	and edx, 3
	
	; clear the memory
	rep stosd
	mov ecx, edx
	rep stosb
	
	pop edi
	ret 8
_fmClear@8 ENDP

END