TITLE "Copies one block to another block"

.586
.model flat             ; memory model
option casemap :none    ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------


; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------

.code

; ----------------------------------------------------------------------------
; Prototype:
;   void __stdcall fmCopy(LPVOID pDest, LPVOID pSrc, size_t dwSize);
;
; Description:
;   Copy the contents of one pointer to another
;
; Returns:
;   (none)
; ----------------------------------------------------------------------------

; ---------------------------------------------------------------------------
; variable offests into ESP upon function entering and adjustment of the
; stack for local variables and register preservation
; ===========================================================================
; ESP + 12 = Dest parameter
; ESP + 16 = Src parameter
; ESP + 20 = length parameter
; ===========================================================================
align 16
_fmCopy@12 proc public
	; save ESI and EDI
	push esi
	push edi
	
	; move parameters into registers
	mov edi, [esp + 12]		; dest
	mov esi, [esp + 16]		; src
	mov ecx, [esp + 20]		; length
	mov edx, [esp + 20]		; length
	
	; set up ECX and EDX to copy DWORD and BYTES through 'rep movs?'
	shr ecx, 2
	and edx, 3
	
	; move the memory DWORD chuncks at a time
	rep movsd
	
	; move the memory the left over bytes
	mov ecx, edx
	rep movsb
	
	; restore our ESI and EDI registers and return
	pop edi
	pop esi
	
	ret 12
_fmCopy@12 ENDP

END