TITLE "Frees a block of memory allocated"

.586
.model flat             ; memory model
option casemap :none    ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
include Kernel32.inc


; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Memory.inc


.code

align 16
; ----------------------------------------------------------------------------
; Prototype:
;   void __stdcall fmFree(const void* pMemory);
;
; Description:
;   Destroys the memory allocated by AlignAlloc() or AlignResizeAlloc().
;   Once the memory has been freed, the pointer is no longer valid.
;
; Returns:
;   (none)
; ----------------------------------------------------------------------------
_fmFree@4 proc public
	; get our address of memory to free
	mov	eax, [esp + 4] 

	; see if we have a NULL pointer
	test	eax, eax
	jz		short @F

	; not a null pointer -- need to get the correct offset of the buffer so
	; we can get the orginal memory pointer	
	and eax, -4
	
	; get the 'real' starting pointer of the memory to be freed
	mov eax, [eax - 8]
	xor ecx, ecx

	; free it now
	push eax
	push ecx
	push [hProcessHeap] 
	call HeapFree
	
@@:
	ret 4
_fmFree@4 ENDP

END