TITLE "Initialize the memory routines"

.586
.model flat             ; memory model
option casemap :none    ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
include Kernel32.inc


; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Memory.inc


.data

align 16
	hProcessHeap dd 0


.code

align 16
; ----------------------------------------------------------------------------
; Prototype:
;   HANDLE __stdcall fmInitialize();
;
;
; Description:
;   Initializes the memory routines.
;
;   NOTE: This function must be called before any type of memory routines
;         are called. If this function isn't, all memory routines will fail
;         and may crash the application.
;
; Returns:
;   Failed :  NULL
;   Success:  Handle of the process heap
; ----------------------------------------------------------------------------
_fmInitialize@0 proc near

	; get the process heap handle
	call GetProcessHeap
	
	; store our value into the global variable
	mov [hProcessHeap], eax

	ret
_fmInitialize@0 endp

END
