@ECHO OFF
@ECHO Creating the ASM??.LIB runtime library

REM ---------------------------------------------------------------------
REM  Change to the ASM source directory to copy the .obj files
REM ---------------------------------------------------------------------
@CD \ASM


REM ---------------------------------------------------------------------
REM  Remove any previous build log file and libraries
REM ---------------------------------------------------------------------
IF EXIST rtl.log DEL rtl.log
IF EXIST LIB\asmA.lib del LIB\asmA.lib
IF EXIST LIB\asmAD.lib del LIB\asmAD.lib
IF EXIST LIB\asmU.lib del LIB\asmU.lib
IF EXIST LIB\asmUD.lib del LIB\asmUD.lib


REM ------------------------------------------------------------------------
REM  Create a temporary directory to hold the OBJs for building the library
REM ------------------------------------------------------------------------
@MD OBJ



REM -------------------------------------------------------------------------
REM                ---------- ANSI DEBUG LIBRARY -----------------
REM -------------------------------------------------------------------------

REM ---------------------------------------------------------------------
REM  Copy each of the sub-library OBJs so we can build a "master" library
REM ---------------------------------------------------------------------
FOR %%X IN (analysis, array, datetime) DO IF EXIST %%X\Debug\*.obj XCOPY %%X\Debug\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (io, mem, misc, str) DO IF EXIST %%X\Debug\*.obj XCOPY %%X\Debug\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (wnd, graphics, zip) DO IF EXIST %%X\Debug\*.obj XCOPY %%X\Debug\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (menu) DO IF EXIST Ownerdrawn\%%X\Debug\*.obj XCOPY Ownerdrawn\%%X\Debug\*.obj obj\ >> \asm\rtl.log


REM ---------------------------------------------------------------------
REM  Build the rtl library and clean up the .OBj files
REM ---------------------------------------------------------------------
@CD OBJ
IF EXIST *.obj \masm32\bin\polib.exe /out:\asm\lib\asmAD.lib *.obj >> \asm\rtl.log
IF EXIST *.obj del *.obj >> \asm\rtl.log
@CD ..





REM -------------------------------------------------------------------------
REM                ---------- ANSI RELEASE LIBRARY -----------------
REM -------------------------------------------------------------------------

REM ---------------------------------------------------------------------
REM  Copy each of the sub-library OBJs so we can build a "master" library
REM ---------------------------------------------------------------------
FOR %%X IN (analysis, array, datetime) DO IF EXIST %%X\Release\*.obj XCOPY %%X\Release\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (io, mem, misc, str) DO IF EXIST %%X\Release\*.obj XCOPY %%X\Release\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (wnd, graphics, zip) DO IF EXIST %%X\Release\*.obj XCOPY %%X\Release\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (menu) DO IF EXIST Ownerdrawn\%%X\Release\*.obj XCOPY Ownerdrawn\%%X\Release\*.obj obj\ >> \asm\rtl.log


REM ---------------------------------------------------------------------
REM  Build the rtl library and clean up the .OBj files
REM ---------------------------------------------------------------------
@CD OBJ
IF EXIST *.obj \masm32\bin\polib.exe /out:\asm\lib\asmA.lib *.obj >> \asm\rtl.log
IF EXIST *.obj del *.obj >> \asm\rtl.log
@CD ..




REM -------------------------------------------------------------------------
REM                ---------- UNICODE DEBUG LIBRARY -----------------
REM -------------------------------------------------------------------------

REM ---------------------------------------------------------------------
REM  Copy each of the sub-library OBJs so we can build a "master" library
REM ---------------------------------------------------------------------
FOR %%X IN (analysis, array, datetime) DO IF EXIST %%X\DebugU\*.obj XCOPY %%X\DebugU\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (io, mem, misc, str) DO IF EXIST %%X\DebugU\*.obj XCOPY %%X\DebugU\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (wnd, graphics, zip) DO IF EXIST %%X\DebugU\*.obj XCOPY %%X\DebugU\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (menu) DO IF EXIST Ownerdrawn\%%X\DebugU\*.obj XCOPY Ownerdrawn\%%X\DebugU\*.obj obj\ >> \asm\rtl.log


REM ---------------------------------------------------------------------
REM  Build the rtl library and clean up the .OBj files
REM ---------------------------------------------------------------------
@CD OBJ
IF EXIST *.obj \masm32\bin\polib.exe /out:\asm\lib\asmUD.lib *.obj >> \asm\rtl.log
IF EXIST *.obj del *.obj >> \asm\rtl.log
@CD ..





REM -------------------------------------------------------------------------
REM              ---------- UNICODE RELEASE LIBRARY -----------------
REM -------------------------------------------------------------------------

REM ---------------------------------------------------------------------
REM  Copy each of the sub-library OBJs so we can build a "master" library
REM ---------------------------------------------------------------------
FOR %%X IN (analysis, array, datetime) DO IF EXIST %%X\ReleaseU\*.obj XCOPY %%X\ReleaseU\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (io, mem, misc, str) DO IF EXIST %%X\ReleaseU\*.obj XCOPY %%X\ReleaseU\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (wnd, graphics, zip) DO IF EXIST %%X\ReleaseU\*.obj XCOPY %%X\ReleaseU\*.obj obj\ >> \asm\rtl.log
FOR %%X IN (menu) DO IF EXIST Ownerdrawn\%%X\ReleaseU\*.obj XCOPY Ownerdrawn\%%X\ReleaseU\*.obj obj\ >> \asm\rtl.log


REM ---------------------------------------------------------------------
REM  Build the rtl library and clean up the .OBj files
REM ---------------------------------------------------------------------
@CD OBJ
IF EXIST *.obj \masm32\bin\polib.exe /out:\asm\lib\asmU.lib *.obj >> \asm\rtl.log
IF EXIST *.obj del *.obj >> \asm\rtl.log
@CD ..




REM ------------------------------------------------------------------------
REM  Remove the temporary directory created
REM ------------------------------------------------------------------------
@RD OBJ
