TITLE "Removes whitespace characters from left side of string"

.586
.model flat             ; memory model
option casemap :none    ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Strings.inc


.code

; ----------------------------------------------------------------------------
; prototype:
;		void __stdcall LeftTrimWhiteSpaceA(char* pString);
;
; Description:
;   ANSI version to remove the following three characters (tab, space, quote)
;   from the left side of the string. Once we find a character that is not one
;   of those characters, it'll stop and move the string down that many bytes.
;
; Return value:
;		(none)
; ----------------------------------------------------------------------------

; ----------------------------------------------------------------------------
; variable offests into ESP upon function entering and adjustment of the
; stack for local variables and register preservation
; ----------------------------------------------------------------------------
; ESP + 0 = (return address)
; ESP + 4 = pString parameter
; ============================================================================
align 16
_LeftTrimWhiteSpaceA@4 proc public
	; load our parameter into a register and check to see if it is empty
	mov	edx, [esp + 4]
	
	; check for end-of-string
	mov	al, byte ptr [edx]
	test	al, al
	je Done
	
	mov	ecx, edx
align 4
@@:
	cmp	al, 9	; tab
	je	@F
	cmp	al, 32	; space
	je @F
	cmp	al, 34	; quote
	jne @F

	; move our pointer and check to see if we are at end
	mov	al, byte ptr [ecx + 1]
	add	ecx, 1
	test	al, al
	jne @B
	
@@:
	; see if we have any characters we need to remove from this string
	cmp	ecx, edx
	je	Done
	
	; move the string to remove the whitespaces found
	push	ecx
	push	edx
	call strCopyA
	
Done:
	ret 4	
_LeftTrimWhiteSpaceA@4 ENDP

END
