TITLE "Concatenate one string on to another"

.586
.model flat				; memory model
option casemap:none	; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Strings.inc


.code

; ----------------------------------------------------------------------------
; prototype:
;		void __stdcall strCatA(char* pDestString, const char* pSrcString);
;
; Description:
;		ANSI version to append Source string (including NULL) into Destination
;
; Return value:
;		(none)
;
; ----------------------------------------------------------------------------
; variable offests into ESP upon function entering and adjustment of the
; stack for local variables and register preservation
; ----------------------------------------------------------------------------
; ESP + 0 = (return address)
; ESP + 4 = pDest parameter
; ESP + 8 = pSrc parameter
; ============================================================================
align 16
_strCatA@8 proc public
	; Find the length of the destination string so we can append the source
	; string to the end.
	push [esp + 4]
	call strLengthA
	
	mov ecx, [esp + 4]	; dest string
	mov edx, [esp + 8]	; source string
	
	; now that we know the length of the destination string, we need to
	; add the address to the length to get the correct offset into the
	; destination buffer to append to.
	add eax, ecx
	
	; copy the source into the destination now
	push edx
	push eax
	call strCopyA
	
	; Return back to caller
	ret 8
_strCatA@8 endp

end
