TITLE "Remove the 'substr' from a string"

.586
.model flat      	; memory model
option casemap:none ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
; (none)


.code

; ----------------------------------------------------------------------------
; prototype:
;		void __stdcall strRemoveA(char* pDestString, const char* pSrcString, const char* pSubString);
;
; Description:
;		ANSI version to remove pSubString from pSrcString and place the final
;		string into pDestString
;
; Return value:
;		(none)
;
; ----------------------------------------------------------------------------
; variable offests into ESP upon function entering and adjustment of the
; stack for local variables and register preservation
; ----------------------------------------------------------------------------
; ESP + 0  = ESI saved register
; ESP + 4  = EDI saved register
; ESP + 8  = (return address)
; ESP + 12 = pDestString parameter
; ESP + 16 = pSrcString parameter
; ESP + 20 = pSubString parameter
; ============================================================================
align 16
_strRemoveA@12 proc public
	; save the ESI and EDI registers
	push edi
	push esi

	; get our parameters into registers now
	mov edx, [esp + 20]
	mov esi, [esp + 16]
	mov edi, [esp + 12]

    mov ah, [edx]           ; 1st remv char in AH
    sub esi, 1

  prescan:
    add esi, 1

  scanloop:
    cmp [esi], ah           ; test for "remv" start char
    je presub

  backin:
    mov al, [esi]
    mov [edi], al
    cmp BYTE PTR [edi], 0   ; exit when zero terminator
    je Done               ; has been written
    add edi, 1
    jmp prescan

align 4
  presub:
    xor ecx, ecx

  subloop:
    mov al, [esi+ecx]
    cmp al, [edx+ecx]
    jne backin              ; jump back on mismatch
    add ecx, 1
    cmp BYTE PTR [edx+ecx], 0   ; test if next byte is zero
    jne subloop

    add esi, ecx            ; add len of remv string to ESI
    jmp scanloop

align 4
  Done:
	; restore the ESI and EDI registers
	pop esi
	pop edi

	; return back to caller
	ret 12
_strRemoveA@12 endp

END