TITLE "Duplicate a string"

.586
.model flat			; memory model
option casemap:none	; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Memory.inc
include asm_Strings.inc


.code

; ----------------------------------------------------------------------------
; prototype:
;		char* __stdcall strDupA(const char* pString);
;
; Description:
;		ANSI version to duplicate source string
;
; Return value:
;		A pointer to the newly duplicated string
;
; ----------------------------------------------------------------------------
; variable offests into ESP upon function entering and adjustment of the
; stack for local variables and register preservation
; ----------------------------------------------------------------------------
; ESP + 0 = (return address)
; ESP + 4 = pString parameter
; ============================================================================
align 16
_strDupA@4 proc public
	; find out the length of the source string
	push [esp + 4]
	call strLengthA
	
	; add one to the length to include the NULL terminator.
	add eax, 1
	
	; allocate memory to hold the duplicated string into.
	push eax
	call fmAlloc

	; save our new buffer pointer to return back to caller.	
	push eax
	
	; now that we have a newly allocated buffer, let's copy the string into it.
	push [esp + 8]  ; need to account for the push adjustment
	push eax
	call strCopyA
	
	; get our return pointer back
	pop eax

	; return back to caller	
	ret 4
_strDupA@4 ENDP

END
