TITLE "Trims whitespace from both sides of a string"

.586
.model flat      			; memory model
option casemap :none    ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Strings.inc


.code
; ----------------------------------------------------------------------------
; prototype:
; void __stdcall TrimWhiteSpaceA(char* pString);

; prototype:
;		void __stdcall TrimWhiteSpaceA(char* pString);
;
; Description:
;		Trims whitespace (Tab, Space or a Quote) from both sides of a ANSI
;       null-terminated string. This function works in-place on the string. 
;
; Returns:
;		(nothing)
;
; ----------------------------------------------------------------------------
; variable offests into ESP upon function entering and adjustment of the
; stack for local variables and register preservation
; ----------------------------------------------------------------------------
; ESP + 0 = (return address)
; ESP + 4 = pString parameter
; ============================================================================

align 16
_TrimWhiteSpaceA@4 proc public
	; trim all white space from the right side of string
	push [esp + 4]
	call RightTrimWhiteSpaceA
	
	; trim all white space from the left side of string
	push [esp + 4]
	call LeftTrimWhiteSpaceA
	
	ret	4
_TrimWhiteSpaceA@4 ENDP

END
