TITLE "Copy a string from one memory location to another"

.586
.model flat			; memory model
option casemap:none	; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
; (none)


.code

; ----------------------------------------------------------------------------
; prototype:
;   wchar_t* __stdcall strCharW(const wchar_t* pString, const wchar_t ch);
;
; Description:
;   UNICODE version to find ch in the string
;
; Return value:
;       Found = Offset into pString
;   Not Found = NULL
;
; ----------------------------------------------------------------------------
; variable offests into ESP upon function entering and adjustment of the
; stack for local variables and register preservation
; ----------------------------------------------------------------------------
; ESP + 0 = (return address)
; ESP + 4 = pString parameter
; ESP + 8 = ch parameter
; ============================================================================
align 16
_strCharW@8 proc public
    ; get our pString parameter
    mov eax, [esp + 4]
    
    ; test for end-of-string
    mov cl, byte ptr [eax]
    test cl, cl
    mov edx, [esp + 8]
    je short NullOrMatch
    
SearchIt:
    ; test for NULL
    test cl, cl
    je short NullOrMatch
    
    ; check to see if character matches
    cmp cl, dl
    je short NullOrMatch
    mov ecx, [eax+2]
    
    ; move to next character
    add eax, 2
    jmp short SearchIt

NullOrMatch:
    ; does this character match ch parameter?
    cmp byte ptr [eax], dl
    je short Done
    
    ; doesn't, so return NULL
    xor eax, eax
    
Done:
    ret 8
_strCharW@8 endp

END
