TITLE "Finding the length of a NULL terminated string"

.586
.model flat			; memory model
option casemap:none	; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
; (none)

; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
; (none)


.code
; ----------------------------------------------------------------------------
; prototype:
;   int strLengthW(const wchar_t* pString);
;
; description:
;   Walk the string to find the NULL terminator at the end. This function
;   assumes you will always have a buffer size divisible by four. size of
;   the buffer is different then the length of the string contained in that
;   buffer.
;
; returns:
;   1 based index where it found the NULL terminator
;
; ----------------------------------------------------------------------------
; variable offests into ESP upon function entering and adjustment of the
; stack for local variables and register preservation
; ----------------------------------------------------------------------------
; ESP + 0 = (return address)
; ESP + 4 = pString parameter
; ============================================================================
align 16
_strLengthW@4 proc public
    ; get the parameter into EDX
    mov edx, [esp + 4]    
    
    ; start at offset 0 into string
    xor eax, eax
    
FindLength:
    ; get the character to see if it is a NULL
    mov ecx, [edx + eax*2]
    
    ; adjust offset and check for NULL in the LO word
    add eax, 1
    test ecx, 0ffffh
    jz short FoundNull
    
    ; adjust offset and check for NULL in the HI word
    add eax, 1
    and ecx, 0ffff0000h
    jnz short FindLength
    
FoundNull:
    ; re-adjust the increment to adjust for the pre-"inc"
    add eax, -1
    
    ; return back to caller with correct length
    ret 4
_strLengthW@4 ENDP

END
