TITLE "Initialize the common controls"

.586
.model flat
option casemap :none      ; case sensitive
option readonly

; include the necessary headers which have the structure, function externs and
; any system variables defined
include comctl32.inc


.code
align 16
; ----------------------------------------------------------------------------
; prototype:
;   void InitWin32Controls();
;
; description (ANSI / UNICODE version):
;   Registers all Win32 common control classes for use with the process.
; ============================================================================
_InitWin32Controls@0 proc public
	; make room on the stack for a INITCOMMONCONTROLSEX structure
	sub esp, sizeof INITCOMMONCONTROLSEX

	; get the address of the structure on the stack
	lea eax, [esp]
	
	; fill in the values we need to set for this structure
	mov dword ptr [esp].INITCOMMONCONTROLSEX.cbSize, sizeof INITCOMMONCONTROLSEX
	mov dword ptr [esp].INITCOMMONCONTROLSEX.styles, ICC_DEFAULT_CLASSES
	
	; initialize the common controls interface
	push eax
	call InitCommonControlsEx
	
	; restore the esp
	add esp, sizeof INITCOMMONCONTROLSEX
	
	; return from function
	ret
_InitWin32Controls@0 ENDP

END
