TITLE "Opens a zip format archive file"

.586
.model flat             ; memory model & calling convention
option casemap :none    ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
include Kernel32.inc


; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_FileIO.inc
include asm_Zip.inc


.code
; ----------------------------------------------------------------------------
; prototype:
;   int __stdcall zaOpenArchiveW(ZARCHIVE* Instance, const wchar_t* pwszFilespec);
;
; Description:
;
; Returns:
;   zipNoError
;   ZipBadZipFile (file type error)
;   ZipMemError   (memory type error)
;
; ----------------------------------------------------------------------------
; variable offests into ESP upon function entering and adjustment of the
; stack for local variables and register preservation
; ----------------------------------------------------------------------------
; ESP + 0 = (return address)
; ESP + 4 = instance parameter
; ESP + 8 = filename parameter
; ============================================================================
align 16
_zaOpenArchiveW@8 proc public
    ; open up the zip format archive file
    push GENERIC_READ
    push [esp + 12] ; filespec parameter
    call fileOpenW
    
    cmp eax, INVALID_HANDLE_VALUE
    je short FailedOpen

    ; finish processing the necessary opening stuff on this zip file.
    push eax
    push [esp + 8]  ; Instance parameter
    call zaOpenCommon    
   
    ret 8

FailedOpen:    
    mov	eax, ZipBadZipFile
	ret 8
_zaOpenArchiveW@8 endp

END
