title		inffast.asm

.586
.model FLAT, stdcall
option casemap :none      ; case sensitive
option readonly

include asm_Zip.inc

.code
align 16
BlockDecompress proc stdcall uses ebx esi edi Stream:dword
	LOCAL OutVar:dword
	LOCAL Len:dword
	LOCAL InVar:dword
	LOCAL lMask:dword
	LOCAL dMask:dword
	LOCAL LenCode:dword
	LOCAL DistCode:dword
	LOCAL Last:dword
	LOCAL Result:dword
	LOCAL v:code
	
	; move our parameter into EAX to work with for copying structure variables
	; into local stack variables.
	mov	eax, [Stream]

	mov	edi, 1
	mov	edx, 1
	
	mov	ecx, [eax].ZipStream.State.lenbits
	shl	edi, cl
	
	mov	ecx, [eax].ZipStream.State.distbits
	shl	edx, cl
	
	sub	edi, 1
	sub	edx, 1
	
	mov	[lMask], edi
	mov	[dMask], edx

	mov	ecx, [eax].ZipStream.State.distcode
	mov	edx, [eax].ZipStream.State.lencode
	mov	[DistCode], ecx
	mov	[LenCode], edx

	mov	esi, [eax].ZipStream.next_in
	mov	edi, [eax].ZipStream.next_out
	mov	edx, [eax].ZipStream.avail_in
	mov	ebx, [eax].ZipStream.State.bits
	lea	edx, [esi+edx-5]
		
	mov	[OutVar], edi
	mov	[Last], edx

	mov	dword ptr [Result], 0
	mov	edx, [eax].ZipStream.State.hold


;---------------------------------------------------------------------------
; EBX = bits
; EDX = hold
; ESI = in
; EAX, ECX and EDI are free working registers
;---------------------------------------------------------------------------
align 4
DoWhile:		; esi < [Last]
	.if ebx < 16
		mov	ecx, ebx
		movzx	eax, word ptr [esi]
		shl	eax, cl
		add	ebx, 16
		add	edx, eax
		add	esi, 2
	.endif

	mov	ecx, edx
	mov	edi, [lMask]
	mov	eax, [LenCode]
	and	ecx, edi
	mov	eax, [eax+ecx*4]
		
@@:
	movzx	ecx, ah
	shr	edx, cl
	sub	bl, cl

	test	al, al
	mov	ecx, eax
	jne	SHORT NewLengthCode

	mov	eax, [OutVar]
	shr	ecx, 16
	add	[OutVar], 1
	mov	byte ptr [eax], cl
	jmp	EndDoWhile

align 4
NewLengthCode:
	test	al, 16
	jne	@F

	test	al, 64
	jne	$L451

	mov	edi, [LenCode]
	mov	eax, 1
	shl	eax, cl
	sub	eax, 1
	shr	ecx, 16
	and	eax, edx
	add	eax, ecx

	mov	eax, [edi+eax*4]
	jmp	@B

align 4
@@:
	shr	eax, 16
	and	cl, 15
	mov	[Len], eax
	je		@F

	.if bl < cl
		mov	eax, ecx
		movzx edi, word ptr [esi]		
		mov	ecx, ebx
		add	esi, 2
		shl	edi, cl
		add	ebx, 16
		add	edx, edi
		mov	ecx, eax
	.endif
	
	mov	edi, 1
	shl	edi, cl
	sub	edi, 1
	and	edi, edx
	sub	bl, cl
	shr	edx, cl
	add	[Len], edi

@@:
	.if ebx < 16
		mov	ecx, ebx
		movzx	eax, word ptr [esi]
		shl	eax, cl
		add	esi, 2
		add	ebx, 16
		add	edx, eax
	.endif

	mov	edi, [DistCode]
	mov	ecx, edx
	and	ecx, [dMask]
	mov	eax, [edi+ecx*4]
	
	mov	cl, ah
	mov	[v], eax

	shr	edx, cl
	sub	bl, cl
	test	al, 16
	jne	@F

align 4	
DoDistanceCode:
	test	al, 64
	jne	EndDoWhile

	mov	ecx, eax
	mov	edi, [v]
	mov	eax, 1
	shr	edi, 16
	shl	eax, cl
	sub	eax, 1
	and	eax, edx
	add	eax, edi
	
	mov	ecx, [DistCode]
	mov	eax, [ecx+eax*4] 

	mov	ecx, eax
	shr	ecx, 8
	shr	edx, cl
	sub	bl, cl
	test	al, 16
	mov	[v], eax
	je		SHORT DoDistanceCode

@@:
	and	al, 15

	.if bl < al
		mov	ecx, ebx
		movzx edi, word ptr [esi]
		shl	edi, cl
		add	ebx, 16
		add	esi, 2
		add	edx, edi
	.endif 
		
	mov	[InVar], esi
	mov	edi, [v]
	shr	edi, 16

	; skip over a few manipulations if we have a zero.
	test	al, al
	je		@F

	mov	cl, al
	sub	bl, al

	mov	eax, 1
	shl	eax, cl
	sub	eax, 1
	and	eax, edx
	add	edi, eax
	shr	edx, cl

@@:
	mov	esi, [OutVar]
	sub	esi, edi

	mov	ecx, [Len]
	mov	edi, [OutVar]
	add	[OutVar], ecx
	rep	movsb

	mov	esi, [InVar]

EndDoWhile:
	cmp	esi, [Last]
	jb		DoWhile
	jmp	SHORT $L422

align 4
$L451:
	test	cl, 32
	je		SHORT EndDoWhile

	mov	ecx, [Last]
	mov	dword ptr [Result], 11

$L422:
	mov	eax, ebx
	sar	eax, 3
	mov	edi, [Stream]
	sub	esi, eax
	add	eax, eax
	add	eax, eax
	add	eax, eax
	sub	ecx, esi
	sub	ebx, eax
	add	ecx, 5
	mov	eax, [OutVar]
	mov	[edi].ZipStream.avail_in, ecx
	mov	[edi].ZipStream.State.bits, ebx
	mov	ecx, [edi].ZipStream.next_out
	sub	ecx, eax
	mov	[edi].ZipStream.next_out, eax
	add	[edi].ZipStream.avail_out, ecx
	mov	[edi].ZipStream.next_in, esi	
	mov	ecx, ebx
	mov	esi, 1
	shl	esi, cl
	sub	esi, 1
	and	esi, edx
	mov	eax, [Result]
	mov	[edi].ZipStream.State.hold, esi

	ret
BlockDecompress endp

END
