TITLE ""

.586
.model flat, stdcall      ; memory model & calling convention
option casemap :none      ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------


; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Memory.inc
include asm_Zip.inc


.code
align 4
; ----------------------------------------------------------------------------
; prototype:
; void __stdcall zaCloseArchive(ZARCHIVE* Instance);
; ----------------------------------------------------------------------------
zaCloseArchive proc uses ebx esi edi Instance:dword
	mov	edi, [Instance]

	mov	eax, [edi].zaInstance.Directory
	test eax, eax
	je short FreeIOPointer

	; set up registers for looping to process each of the array elements
	; ebx = counter
	; esi = address of element array
	lea	esi, [eax].zdInstance.Array
	mov	ebx, [eax].zdInstance.ArrayCount
	test ebx, ebx
	je short FreeDirPointer

	; now loop through and free the filename's memory
@@:
	; get the correct address pointer to free
	mov	ecx, [esi]
	push [ecx].zeInstance.FileName	
	call fmFree

	; move our working pointer to next object
	add esi, sizeof dword

	; are we at the end of the array? 
	sub ebx, 1 
	jnz short @B

	; free the base allocation which contain the array information
FreeDirPointer:
	push [edi].zaInstance.Directory
	call fmFree

FreeIOPointer:
	mov eax, [edi].zaInstance.IO
	test eax, eax
	je short FreeDone

	push eax
	call fmFree

FreeDone:
	ret
zaCloseArchive endp

END
