TITLE ""

.586
.model flat, stdcall      ; memory model & calling convention
option casemap :none      ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------


; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Zip.inc


.code

; ----------------------------------------------------------------------------
; prototype:
; int __stdcall zaOpenEntry(ZENTRY* Instance, DWORD* dwFileSize);
; ----------------------------------------------------------------------------
align 16
zaOpenEntry proc uses ebx edi Instance:dword, IO:dword, FileSize:dword
	mov	ecx, [Instance]
	mov	edx, [IO]
	mov	edi, [FileSize]
	lea	eax, [edx].zfInstance.MemBuffer
	mov	ebx, [ecx].zeInstance.CDHdr
	mov	dword ptr [edi], 0

	add	eax, [ebx].CentralDirectoryHeader.dwOffset
	mov	[edx].zfInstance.MemPosition, eax
	
	; read in the local information for this entry
	push edx
	push ecx
	call zeReadLocal
	test eax, eax
	jne	short @F

	mov	eax, ZipBadZipFile
	ret

@@:
	; if the zip entry has a password, abort -- password support is not in this version
	mov	eax, dword ptr [ebx].CentralDirectoryHeader.Common.Flag
	test eax, 1
	je short @F
	
	mov	eax, ZipBadPassword
	ret
	
@@: 
	; make sure we have a Method if deflation (0 = UNCOMPRESSED, 8 = Z_DEFLATED)
	movzx eax, word ptr [ebx].CentralDirectoryHeader.Common.Method
	test eax, eax
	je short @F
	cmp	eax, Z_DEFLATED
	je short @F
	
	mov	eax, ZipVersionError
	ret
	
@@:
	mov	ecx, [ebx].CentralDirectoryHeader.Common.UnCompSize
	mov	eax, zipNoError
	mov	dword ptr [edi], ecx
	ret
zaOpenEntry endp

END
