TITLE ""

.586
.model flat, stdcall      ; memory model & calling convention
option casemap :none      ; case sensitive
option readonly

; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------


; ----------------------------------------------------------------------------
; Library includes
; ----------------------------------------------------------------------------
include asm_Zip.inc

.const
align 16
EntryLocalSignature db 050h, 04bh, 03h, 04h


.code
; ----------------------------------------------------------------------------
; prototype:
; BOOL __stdcall zeReadLocal(ZipEntry* pEntry, StorageIO* pStorage);
; ----------------------------------------------------------------------------
align 16
zeReadLocal proc private uses esi edi Instance:dword, IO:dword
	; read in the local header information for this zip entry
	mov	edx, sizeof CentralDirectoryLocalHeader
	mov	ecx, [IO]
	mov	eax, [ecx].zfInstance.MemPosition
		
	; move the current memory pointer to the new position
	add	[ecx].zfInstance.MemPosition, edx

	; validate the local signature with the directory signature
	mov	ecx, offset flat:EntryLocalSignature
	mov	edx, [Instance]

	mov	ecx, [ecx]
	mov	edx, [edx].zeInstance.CDHdr

	cmp	[eax], ecx
	jne	short Failure

	; validate basic information between entry and central directory.
	; these values must be the same
	lea	esi, [eax].CentralDirectoryLocalHeader.Common
	lea	edi, [edx].CentralDirectoryHeader.Common

	; sizeof(CentralDirectoryBaseHeader) - sizeof(word) should always be divisible by four
	mov	ecx, (sizeof CentralDirectoryCommonHeader - sizeof word) / 4

	repe cmpsd
	je short @F

	; since they aren't equal, we now need to check and see if this
	; entry is a data descriptor.
	test byte ptr [eax].CentralDirectoryLocalHeader.Common.Flag, 8
	jne	short @F
	
	cmp	[eax].CentralDirectoryLocalHeader.Common.Crc32, 0
	jne	short Failure

@@:
	; seek past our local filename and the extra field data
	mov	edx, [IO]
	movzx esi, word ptr [eax].CentralDirectoryLocalHeader.Common.FileNameSize
	movzx edi, word ptr [eax].CentralDirectoryLocalHeader.Common.ExtraField
	
	; begin at the current memory position pointer
	mov	ecx, [edx].zfInstance.MemPosition
	
	; add the offsets of our FileNameSize and ExtraField
	add	ecx, esi
	add	ecx, edi
		
	; save the current memory position pointer into the file
	mov	[edx].zfInstance.MemPosition, ecx

	; success
	mov	eax, 1
	ret
	
Failure:
	xor	eax, eax	
	ret
zeReadLocal endp

END
